/* 正文插件合并脚本 */
/*
 * Lazy Load - jQuery plugin for lazy loading images
 *
 * Copyright (c) 2007-2012 Mika Tuupola
 *
 * Licensed under the MIT license:
 *   http://www.opensource.org/licenses/mit-license.php
 *
 * Project home:
 *   http://www.appelsiini.net/projects/lazyload
 *
 * Version:  1.7.2
 *
 */
;(function(a,b){$window=a(b),a.fn.lazyload=function(c){function f(){var b=0;d.each(function(){var c=a(this);if(e.skip_invisible&&!c.is(":visible"))return;if(!a.abovethetop(this,e)&&!a.leftofbegin(this,e))if(!a.belowthefold(this,e)&&!a.rightoffold(this,e))c.trigger("appear");else if(++b>e.failure_limit)return!1})}var d=this,e={threshold:0,failure_limit:0,event:"scroll",effect:"show",container:b,data_attribute:"original",skip_invisible:!0,appear:null,load:null};return c&&(undefined!==c.failurelimit&&(c.failure_limit=c.failurelimit,delete c.failurelimit),undefined!==c.effectspeed&&(c.effect_speed=c.effectspeed,delete c.effectspeed),a.extend(e,c)),$container=e.container===undefined||e.container===b?$window:a(e.container),0===e.event.indexOf("scroll")&&$container.bind(e.event,function(a){return f()}),this.each(function(){var b=this,c=a(b);b.loaded=!1,c.one("appear",function(){if(!this.loaded){if(e.appear){var f=d.length;e.appear.call(b,f,e)}a("<img />").bind("load",function(){c.hide().attr("src",c.data(e.data_attribute))[e.effect](e.effect_speed),b.loaded=!0;var f=a.grep(d,function(a){return!a.loaded});d=a(f);if(e.load){var g=d.length;e.load.call(b,g,e)}}).attr("src",c.data(e.data_attribute))}}),0!==e.event.indexOf("scroll")&&c.bind(e.event,function(a){b.loaded||c.trigger("appear")})}),$window.bind("resize",function(a){f()}),f(),this},a.belowthefold=function(c,d){var e;return d.container===undefined||d.container===b?e=$window.height()+$window.scrollTop():e=$container.offset().top+$container.height(),e<=a(c).offset().top-d.threshold},a.rightoffold=function(c,d){var e;return d.container===undefined||d.container===b?e=$window.width()+$window.scrollLeft():e=$container.offset().left+$container.width(),e<=a(c).offset().left-d.threshold},a.abovethetop=function(c,d){var e;return d.container===undefined||d.container===b?e=$window.scrollTop():e=$container.offset().top,e>=a(c).offset().top+d.threshold+a(c).height()},a.leftofbegin=function(c,d){var e;return d.container===undefined||d.container===b?e=$window.scrollLeft():e=$container.offset().left,e>=a(c).offset().left+d.threshold+a(c).width()},a.inviewport=function(b,c){return!a.rightofscreen(b,c)&&!a.leftofscreen(b,c)&&!a.belowthefold(b,c)&&!a.abovethetop(b,c)},a.extend(a.expr[":"],{"below-the-fold":function(c){return a.belowthefold(c,{threshold:0,container:b})},"above-the-top":function(c){return!a.belowthefold(c,{threshold:0,container:b})},"right-of-screen":function(c){return a.rightoffold(c,{threshold:0,container:b})},"left-of-screen":function(c){return!a.rightoffold(c,{threshold:0,container:b})},"in-viewport":function(c){return!a.inviewport(c,{threshold:0,container:b})},"above-the-fold":function(c){return!a.belowthefold(c,{threshold:0,container:b})},"right-of-fold":function(c){return a.rightoffold(c,{threshold:0,container:b})},"left-of-fold":function(c){return!a.rightoffold(c,{threshold:0,container:b})}})})(jQuery,window);

/**
 * Author: Sergey Bondarenko (BR0kEN)
 * E-mail: broken@propeople.com.ua
 * Github: https://github.com/BR0kEN-/jTap
 * Updated: June 2, 2014
 * Version: 0.2.9
 */
!function(t,e){"use strict";var n={start:"touchstart mousedown",end:"touchend mouseup"};t.event.special[e]={setup:function(){t(this).off("click").on(n.start+" "+n.end,function(t){n.E=t.originalEvent.changedTouches?t.originalEvent.changedTouches[0]:t}).on(n.start,function(t){t.which&&1!==t.which||(n.target=t.target,n.time=(new Date).getTime(),n.X=n.E.pageX,n.Y=n.E.pageY)}).on(n.end,function(a){n.target===a.target&&(new Date).getTime()-n.time<750&&n.X===n.E.pageX&&n.Y===n.E.pageY&&(a.type=e,a.pageX=n.E.pageX,a.pageY=n.E.pageY,t.event.dispatch.call(this,a))})},remove:function(){t(this).off(n.start+" "+n.end)}},t.fn[e]=function(t){return this[t?"on":"trigger"](e,t)}}(jQuery,"tap");

/*highlightjs*/
/*! highlight.js v9.7.0 | BSD3 License | git.io/hljslicense */
!function(e){var n="object"==typeof window&&window||"object"==typeof self&&self;"undefined"!=typeof exports?e(exports):n&&(n.hljs=e({}),"function"==typeof define&&define.amd&&define([],function(){return n.hljs}))}(function(e){function n(e){return e.replace(/[&<>]/gm,function(e){return I[e]})}function t(e){return e.nodeName.toLowerCase()}function r(e,n){var t=e&&e.exec(n);return t&&0===t.index}function a(e){return k.test(e)}function i(e){var n,t,r,i,o=e.className+" ";if(o+=e.parentNode?e.parentNode.className:"",t=B.exec(o))return R(t[1])?t[1]:"no-highlight";for(o=o.split(/\s+/),n=0,r=o.length;r>n;n++)if(i=o[n],a(i)||R(i))return i}function o(e,n){var t,r={};for(t in e)r[t]=e[t];if(n)for(t in n)r[t]=n[t];return r}function u(e){var n=[];return function r(e,a){for(var i=e.firstChild;i;i=i.nextSibling)3===i.nodeType?a+=i.nodeValue.length:1===i.nodeType&&(n.push({event:"start",offset:a,node:i}),a=r(i,a),t(i).match(/br|hr|img|input/)||n.push({event:"stop",offset:a,node:i}));return a}(e,0),n}function c(e,r,a){function i(){return e.length&&r.length?e[0].offset!==r[0].offset?e[0].offset<r[0].offset?e:r:"start"===r[0].event?e:r:e.length?e:r}function o(e){function r(e){return" "+e.nodeName+'="'+n(e.value)+'"'}l+="<"+t(e)+w.map.call(e.attributes,r).join("")+">"}function u(e){l+="</"+t(e)+">"}function c(e){("start"===e.event?o:u)(e.node)}for(var s=0,l="",f=[];e.length||r.length;){var g=i();if(l+=n(a.substr(s,g[0].offset-s)),s=g[0].offset,g===e){f.reverse().forEach(u);do c(g.splice(0,1)[0]),g=i();while(g===e&&g.length&&g[0].offset===s);f.reverse().forEach(o)}else"start"===g[0].event?f.push(g[0].node):f.pop(),c(g.splice(0,1)[0])}return l+n(a.substr(s))}function s(e){function n(e){return e&&e.source||e}function t(t,r){return new RegExp(n(t),"m"+(e.cI?"i":"")+(r?"g":""))}function r(a,i){if(!a.compiled){if(a.compiled=!0,a.k=a.k||a.bK,a.k){var u={},c=function(n,t){e.cI&&(t=t.toLowerCase()),t.split(" ").forEach(function(e){var t=e.split("|");u[t[0]]=[n,t[1]?Number(t[1]):1]})};"string"==typeof a.k?c("keyword",a.k):E(a.k).forEach(function(e){c(e,a.k[e])}),a.k=u}a.lR=t(a.l||/\w+/,!0),i&&(a.bK&&(a.b="\\b("+a.bK.split(" ").join("|")+")\\b"),a.b||(a.b=/\B|\b/),a.bR=t(a.b),a.e||a.eW||(a.e=/\B|\b/),a.e&&(a.eR=t(a.e)),a.tE=n(a.e)||"",a.eW&&i.tE&&(a.tE+=(a.e?"|":"")+i.tE)),a.i&&(a.iR=t(a.i)),null==a.r&&(a.r=1),a.c||(a.c=[]);var s=[];a.c.forEach(function(e){e.v?e.v.forEach(function(n){s.push(o(e,n))}):s.push("self"===e?a:e)}),a.c=s,a.c.forEach(function(e){r(e,a)}),a.starts&&r(a.starts,i);var l=a.c.map(function(e){return e.bK?"\\.?("+e.b+")\\.?":e.b}).concat([a.tE,a.i]).map(n).filter(Boolean);a.t=l.length?t(l.join("|"),!0):{exec:function(){return null}}}}r(e)}function l(e,t,a,i){function o(e,n){var t,a;for(t=0,a=n.c.length;a>t;t++)if(r(n.c[t].bR,e))return n.c[t]}function u(e,n){if(r(e.eR,n)){for(;e.endsParent&&e.parent;)e=e.parent;return e}return e.eW?u(e.parent,n):void 0}function c(e,n){return!a&&r(n.iR,e)}function g(e,n){var t=N.cI?n[0].toLowerCase():n[0];return e.k.hasOwnProperty(t)&&e.k[t]}function h(e,n,t,r){var a=r?"":y.classPrefix,i='<span class="'+a,o=t?"":C;return i+=e+'">',i+n+o}function p(){var e,t,r,a;if(!E.k)return n(B);for(a="",t=0,E.lR.lastIndex=0,r=E.lR.exec(B);r;)a+=n(B.substr(t,r.index-t)),e=g(E,r),e?(M+=e[1],a+=h(e[0],n(r[0]))):a+=n(r[0]),t=E.lR.lastIndex,r=E.lR.exec(B);return a+n(B.substr(t))}function d(){var e="string"==typeof E.sL;if(e&&!x[E.sL])return n(B);var t=e?l(E.sL,B,!0,L[E.sL]):f(B,E.sL.length?E.sL:void 0);return E.r>0&&(M+=t.r),e&&(L[E.sL]=t.top),h(t.language,t.value,!1,!0)}function b(){k+=null!=E.sL?d():p(),B=""}function v(e){k+=e.cN?h(e.cN,"",!0):"",E=Object.create(e,{parent:{value:E}})}function m(e,n){if(B+=e,null==n)return b(),0;var t=o(n,E);if(t)return t.skip?B+=n:(t.eB&&(B+=n),b(),t.rB||t.eB||(B=n)),v(t,n),t.rB?0:n.length;var r=u(E,n);if(r){var a=E;a.skip?B+=n:(a.rE||a.eE||(B+=n),b(),a.eE&&(B=n));do E.cN&&(k+=C),E.skip||(M+=E.r),E=E.parent;while(E!==r.parent);return r.starts&&v(r.starts,""),a.rE?0:n.length}if(c(n,E))throw new Error('Illegal lexeme "'+n+'" for mode "'+(E.cN||"<unnamed>")+'"');return B+=n,n.length||1}var N=R(e);if(!N)throw new Error('Unknown language: "'+e+'"');s(N);var w,E=i||N,L={},k="";for(w=E;w!==N;w=w.parent)w.cN&&(k=h(w.cN,"",!0)+k);var B="",M=0;try{for(var I,j,O=0;;){if(E.t.lastIndex=O,I=E.t.exec(t),!I)break;j=m(t.substr(O,I.index-O),I[0]),O=I.index+j}for(m(t.substr(O)),w=E;w.parent;w=w.parent)w.cN&&(k+=C);return{r:M,value:k,language:e,top:E}}catch(T){if(T.message&&-1!==T.message.indexOf("Illegal"))return{r:0,value:n(t)};throw T}}function f(e,t){t=t||y.languages||E(x);var r={r:0,value:n(e)},a=r;return t.filter(R).forEach(function(n){var t=l(n,e,!1);t.language=n,t.r>a.r&&(a=t),t.r>r.r&&(a=r,r=t)}),a.language&&(r.second_best=a),r}function g(e){return y.tabReplace||y.useBR?e.replace(M,function(e,n){return y.useBR&&"\n"===e?"<br>":y.tabReplace?n.replace(/\t/g,y.tabReplace):void 0}):e}function h(e,n,t){var r=n?L[n]:t,a=[e.trim()];return e.match(/\bhljs\b/)||a.push("hljs"),-1===e.indexOf(r)&&a.push(r),a.join(" ").trim()}function p(e){var n,t,r,o,s,p=i(e);a(p)||(y.useBR?(n=document.createElementNS("http://www.w3.org/1999/xhtml","div"),n.innerHTML=e.innerHTML.replace(/\n/g,"").replace(/<br[ \/]*>/g,"\n")):n=e,s=n.textContent,r=p?l(p,s,!0):f(s),t=u(n),t.length&&(o=document.createElementNS("http://www.w3.org/1999/xhtml","div"),o.innerHTML=r.value,r.value=c(t,u(o),s)),r.value=g(r.value),e.innerHTML=r.value,e.className=h(e.className,p,r.language),e.result={language:r.language,re:r.r},r.second_best&&(e.second_best={language:r.second_best.language,re:r.second_best.r}))}function d(e){y=o(y,e)}function b(){if(!b.called){b.called=!0;var e=document.querySelectorAll("pre code");w.forEach.call(e,p)}}function v(){addEventListener("DOMContentLoaded",b,!1),addEventListener("load",b,!1)}function m(n,t){var r=x[n]=t(e);r.aliases&&r.aliases.forEach(function(e){L[e]=n})}function N(){return E(x)}function R(e){return e=(e||"").toLowerCase(),x[e]||x[L[e]]}var w=[],E=Object.keys,x={},L={},k=/^(no-?highlight|plain|text)$/i,B=/\blang(?:uage)?-([\w-]+)\b/i,M=/((^(<[^>]+>|\t|)+|(?:\n)))/gm,C="</span>",y={classPrefix:"hljs-",tabReplace:null,useBR:!1,languages:void 0},I={"&":"&amp;","<":"&lt;",">":"&gt;"};return e.highlight=l,e.highlightAuto=f,e.fixMarkup=g,e.highlightBlock=p,e.configure=d,e.initHighlighting=b,e.initHighlightingOnLoad=v,e.registerLanguage=m,e.listLanguages=N,e.getLanguage=R,e.inherit=o,e.IR="[a-zA-Z]\\w*",e.UIR="[a-zA-Z_]\\w*",e.NR="\\b\\d+(\\.\\d+)?",e.CNR="(-?)(\\b0[xX][a-fA-F0-9]+|(\\b\\d+(\\.\\d*)?|\\.\\d+)([eE][-+]?\\d+)?)",e.BNR="\\b(0b[01]+)",e.RSR="!|!=|!==|%|%=|&|&&|&=|\\*|\\*=|\\+|\\+=|,|-|-=|/=|/|:|;|<<|<<=|<=|<|===|==|=|>>>=|>>=|>=|>>>|>>|>|\\?|\\[|\\{|\\(|\\^|\\^=|\\||\\|=|\\|\\||~",e.BE={b:"\\\\[\\s\\S]",r:0},e.ASM={cN:"string",b:"'",e:"'",i:"\\n",c:[e.BE]},e.QSM={cN:"string",b:'"',e:'"',i:"\\n",c:[e.BE]},e.PWM={b:/\b(a|an|the|are|I'm|isn't|don't|doesn't|won't|but|just|should|pretty|simply|enough|gonna|going|wtf|so|such|will|you|your|like)\b/},e.C=function(n,t,r){var a=e.inherit({cN:"comment",b:n,e:t,c:[]},r||{});return a.c.push(e.PWM),a.c.push({cN:"doctag",b:"(?:TODO|FIXME|NOTE|BUG|XXX):",r:0}),a},e.CLCM=e.C("//","$"),e.CBCM=e.C("/\\*","\\*/"),e.HCM=e.C("#","$"),e.NM={cN:"number",b:e.NR,r:0},e.CNM={cN:"number",b:e.CNR,r:0},e.BNM={cN:"number",b:e.BNR,r:0},e.CSSNM={cN:"number",b:e.NR+"(%|em|ex|ch|rem|vw|vh|vmin|vmax|cm|mm|in|pt|pc|px|deg|grad|rad|turn|s|ms|Hz|kHz|dpi|dpcm|dppx)?",r:0},e.RM={cN:"regexp",b:/\//,e:/\/[gimuy]*/,i:/\n/,c:[e.BE,{b:/\[/,e:/\]/,r:0,c:[e.BE]}]},e.TM={cN:"title",b:e.IR,r:0},e.UTM={cN:"title",b:e.UIR,r:0},e.METHOD_GUARD={b:"\\.\\s*"+e.UIR,r:0},e});hljs.registerLanguage("xml",function(s){var e="[A-Za-z0-9\\._:-]+",t={eW:!0,i:/</,r:0,c:[{cN:"attr",b:e,r:0},{b:/=\s*/,r:0,c:[{cN:"string",endsParent:!0,v:[{b:/"/,e:/"/},{b:/'/,e:/'/},{b:/[^\s"'=<>`]+/}]}]}]};return{aliases:["html","xhtml","rss","atom","xjb","xsd","xsl","plist"],cI:!0,c:[{cN:"meta",b:"<!DOCTYPE",e:">",r:10,c:[{b:"\\[",e:"\\]"}]},s.C("<!--","-->",{r:10}),{b:"<\\!\\[CDATA\\[",e:"\\]\\]>",r:10},{b:/<\?(php)?/,e:/\?>/,sL:"php",c:[{b:"/\\*",e:"\\*/",skip:!0}]},{cN:"tag",b:"<style(?=\\s|>|$)",e:">",k:{name:"style"},c:[t],starts:{e:"</style>",rE:!0,sL:["css","xml"]}},{cN:"tag",b:"<script(?=\\s|>|$)",e:">",k:{name:"script"},c:[t],starts:{e:"</script>",rE:!0,sL:["actionscript","javascript","handlebars","xml"]}},{cN:"meta",v:[{b:/<\?xml/,e:/\?>/,r:10},{b:/<\?\w+/,e:/\?>/}]},{cN:"tag",b:"</?",e:"/?>",c:[{cN:"name",b:/[^\/><\s]+/,r:0},t]}]}});hljs.registerLanguage("markdown",function(e){return{aliases:["md","mkdown","mkd"],c:[{cN:"section",v:[{b:"^#{1,6}",e:"$"},{b:"^.+?\\n[=-]{2,}$"}]},{b:"<",e:">",sL:"xml",r:0},{cN:"bullet",b:"^([*+-]|(\\d+\\.))\\s+"},{cN:"strong",b:"[*_]{2}.+?[*_]{2}"},{cN:"emphasis",v:[{b:"\\*.+?\\*"},{b:"_.+?_",r:0}]},{cN:"quote",b:"^>\\s+",e:"$"},{cN:"code",v:[{b:"^```w*s*$",e:"^```s*$"},{b:"`.+?`"},{b:"^( {4}|	)",e:"$",r:0}]},{b:"^[-\\*]{3,}",e:"$"},{b:"\\[.+?\\][\\(\\[].*?[\\)\\]]",rB:!0,c:[{cN:"string",b:"\\[",e:"\\]",eB:!0,rE:!0,r:0},{cN:"link",b:"\\]\\(",e:"\\)",eB:!0,eE:!0},{cN:"symbol",b:"\\]\\[",e:"\\]",eB:!0,eE:!0}],r:10},{b:/^\[[^\n]+\]:/,rB:!0,c:[{cN:"symbol",b:/\[/,e:/\]/,eB:!0,eE:!0},{cN:"link",b:/:\s*/,e:/$/,eB:!0}]}]}});hljs.registerLanguage("python",function(e){var r={cN:"meta",b:/^(>>>|\.\.\.) /},b={cN:"string",c:[e.BE],v:[{b:/(u|b)?r?'''/,e:/'''/,c:[r],r:10},{b:/(u|b)?r?"""/,e:/"""/,c:[r],r:10},{b:/(u|r|ur)'/,e:/'/,r:10},{b:/(u|r|ur)"/,e:/"/,r:10},{b:/(b|br)'/,e:/'/},{b:/(b|br)"/,e:/"/},e.ASM,e.QSM]},a={cN:"number",r:0,v:[{b:e.BNR+"[lLjJ]?"},{b:"\\b(0o[0-7]+)[lLjJ]?"},{b:e.CNR+"[lLjJ]?"}]},l={cN:"params",b:/\(/,e:/\)/,c:["self",r,a,b]};return{aliases:["py","gyp"],k:{keyword:"and elif is global as in if from raise for except finally print import pass return exec else break not with class assert yield try while continue del or def lambda async await nonlocal|10 None True False",built_in:"Ellipsis NotImplemented"},i:/(<\/|->|\?)/,c:[r,a,b,e.HCM,{v:[{cN:"function",bK:"def",r:10},{cN:"class",bK:"class"}],e:/:/,i:/[${=;\n,]/,c:[e.UTM,l,{b:/->/,eW:!0,k:"None"}]},{cN:"meta",b:/^[\t ]*@/,e:/$/},{b:/\b(print|exec)\(/}]}});hljs.registerLanguage("makefile",function(e){var a={cN:"variable",b:/\$\(/,e:/\)/,c:[e.BE]};return{aliases:["mk","mak"],c:[e.HCM,{b:/^\w+\s*\W*=/,rB:!0,r:0,starts:{e:/\s*\W*=/,eE:!0,starts:{e:/$/,r:0,c:[a]}}},{cN:"section",b:/^[\w]+:\s*$/},{cN:"meta",b:/^\.PHONY:/,e:/$/,k:{"meta-keyword":".PHONY"},l:/[\.\w]+/},{b:/^\t+/,e:/$/,r:0,c:[e.QSM,a]}]}});hljs.registerLanguage("css",function(e){var c="[a-zA-Z-][a-zA-Z0-9_-]*",t={b:/[A-Z\_\.\-]+\s*:/,rB:!0,e:";",eW:!0,c:[{cN:"attribute",b:/\S/,e:":",eE:!0,starts:{eW:!0,eE:!0,c:[{b:/[\w-]+\(/,rB:!0,c:[{cN:"built_in",b:/[\w-]+/},{b:/\(/,e:/\)/,c:[e.ASM,e.QSM]}]},e.CSSNM,e.QSM,e.ASM,e.CBCM,{cN:"number",b:"#[0-9A-Fa-f]+"},{cN:"meta",b:"!important"}]}}]};return{cI:!0,i:/[=\/|'\$]/,c:[e.CBCM,{cN:"selector-id",b:/#[A-Za-z0-9_-]+/},{cN:"selector-class",b:/\.[A-Za-z0-9_-]+/},{cN:"selector-attr",b:/\[/,e:/\]/,i:"$"},{cN:"selector-pseudo",b:/:(:)?[a-zA-Z0-9\_\-\+\(\)"'.]+/},{b:"@(font-face|page)",l:"[a-z-]+",k:"font-face page"},{b:"@",e:"[{;]",i:/:/,c:[{cN:"keyword",b:/\w+/},{b:/\s/,eW:!0,eE:!0,r:0,c:[e.ASM,e.QSM,e.CSSNM]}]},{cN:"selector-tag",b:c,r:0},{b:"{",e:"}",i:/\S/,c:[e.CBCM,t]}]}});hljs.registerLanguage("ruby",function(e){var b="[a-zA-Z_]\\w*[!?=]?|[-+~]\\@|<<|>>|=~|===?|<=>|[<>]=?|\\*\\*|[-/+%^&*~`|]|\\[\\]=?",r={keyword:"and then defined module in return redo if BEGIN retry end for self when next until do begin unless END rescue else break undef not super class case require yield alias while ensure elsif or include attr_reader attr_writer attr_accessor",literal:"true false nil"},c={cN:"doctag",b:"@[A-Za-z]+"},a={b:"#<",e:">"},s=[e.C("#","$",{c:[c]}),e.C("^\\=begin","^\\=end",{c:[c],r:10}),e.C("^__END__","\\n$")],n={cN:"subst",b:"#\\{",e:"}",k:r},t={cN:"string",c:[e.BE,n],v:[{b:/'/,e:/'/},{b:/"/,e:/"/},{b:/`/,e:/`/},{b:"%[qQwWx]?\\(",e:"\\)"},{b:"%[qQwWx]?\\[",e:"\\]"},{b:"%[qQwWx]?{",e:"}"},{b:"%[qQwWx]?<",e:">"},{b:"%[qQwWx]?/",e:"/"},{b:"%[qQwWx]?%",e:"%"},{b:"%[qQwWx]?-",e:"-"},{b:"%[qQwWx]?\\|",e:"\\|"},{b:/\B\?(\\\d{1,3}|\\x[A-Fa-f0-9]{1,2}|\\u[A-Fa-f0-9]{4}|\\?\S)\b/},{b:/<<(-?)\w+$/,e:/^\s*\w+$/}]},i={cN:"params",b:"\\(",e:"\\)",endsParent:!0,k:r},d=[t,a,{cN:"class",bK:"class module",e:"$|;",i:/=/,c:[e.inherit(e.TM,{b:"[A-Za-z_]\\w*(::\\w+)*(\\?|\\!)?"}),{b:"<\\s*",c:[{b:"("+e.IR+"::)?"+e.IR}]}].concat(s)},{cN:"function",bK:"def",e:"$|;",c:[e.inherit(e.TM,{b:b}),i].concat(s)},{b:e.IR+"::"},{cN:"symbol",b:e.UIR+"(\\!|\\?)?:",r:0},{cN:"symbol",b:":(?!\\s)",c:[t,{b:b}],r:0},{cN:"number",b:"(\\b0[0-7_]+)|(\\b0x[0-9a-fA-F_]+)|(\\b[1-9][0-9_]*(\\.[0-9_]+)?)|[0_]\\b",r:0},{b:"(\\$\\W)|((\\$|\\@\\@?)(\\w+))"},{cN:"params",b:/\|/,e:/\|/,k:r},{b:"("+e.RSR+")\\s*",c:[a,{cN:"regexp",c:[e.BE,n],i:/\n/,v:[{b:"/",e:"/[a-z]*"},{b:"%r{",e:"}[a-z]*"},{b:"%r\\(",e:"\\)[a-z]*"},{b:"%r!",e:"![a-z]*"},{b:"%r\\[",e:"\\][a-z]*"}]}].concat(s),r:0}].concat(s);n.c=d,i.c=d;var l="[>?]>",o="[\\w#]+\\(\\w+\\):\\d+:\\d+>",w="(\\w+-)?\\d+\\.\\d+\\.\\d(p\\d+)?[^>]+>",u=[{b:/^\s*=>/,starts:{e:"$",c:d}},{cN:"meta",b:"^("+l+"|"+o+"|"+w+")",starts:{e:"$",c:d}}];return{aliases:["rb","gemspec","podspec","thor","irb"],k:r,i:/\/\*/,c:s.concat(u).concat(d)}});hljs.registerLanguage("cpp",function(t){var e={cN:"keyword",b:"\\b[a-z\\d_]*_t\\b"},r={cN:"string",v:[{b:'(u8?|U)?L?"',e:'"',i:"\\n",c:[t.BE]},{b:'(u8?|U)?R"',e:'"',c:[t.BE]},{b:"'\\\\?.",e:"'",i:"."}]},s={cN:"number",v:[{b:"\\b(0b[01']+)"},{b:"\\b([\\d']+(\\.[\\d']*)?|\\.[\\d']+)(u|U|l|L|ul|UL|f|F|b|B)"},{b:"(-?)(\\b0[xX][a-fA-F0-9']+|(\\b[\\d']+(\\.[\\d']*)?|\\.[\\d']+)([eE][-+]?[\\d']+)?)"}],r:0},i={cN:"meta",b:/#\s*[a-z]+\b/,e:/$/,k:{"meta-keyword":"if else elif endif define undef warning error line pragma ifdef ifndef include"},c:[{b:/\\\n/,r:0},t.inherit(r,{cN:"meta-string"}),{cN:"meta-string",b:"<",e:">",i:"\\n"},t.CLCM,t.CBCM]},a=t.IR+"\\s*\\(",c={keyword:"int float while private char catch import module export virtual operator sizeof dynamic_cast|10 typedef const_cast|10 const struct for static_cast|10 union namespace unsigned long volatile static protected bool template mutable if public friend do goto auto void enum else break extern using class asm case typeid short reinterpret_cast|10 default double register explicit signed typename try this switch continue inline delete alignof constexpr decltype noexcept static_assert thread_local restrict _Bool complex _Complex _Imaginary atomic_bool atomic_char atomic_schar atomic_uchar atomic_short atomic_ushort atomic_int atomic_uint atomic_long atomic_ulong atomic_llong atomic_ullong new throw return",built_in:"std string cin cout cerr clog stdin stdout stderr stringstream istringstream ostringstream auto_ptr deque list queue stack vector map set bitset multiset multimap unordered_set unordered_map unordered_multiset unordered_multimap array shared_ptr abort abs acos asin atan2 atan calloc ceil cosh cos exit exp fabs floor fmod fprintf fputs free frexp fscanf isalnum isalpha iscntrl isdigit isgraph islower isprint ispunct isspace isupper isxdigit tolower toupper labs ldexp log10 log malloc realloc memchr memcmp memcpy memset modf pow printf putchar puts scanf sinh sin snprintf sprintf sqrt sscanf strcat strchr strcmp strcpy strcspn strlen strncat strncmp strncpy strpbrk strrchr strspn strstr tanh tan vfprintf vprintf vsprintf endl initializer_list unique_ptr",literal:"true false nullptr NULL"},n=[e,t.CLCM,t.CBCM,s,r];return{aliases:["c","cc","h","c++","h++","hpp"],k:c,i:"</",c:n.concat([i,{b:"\\b(deque|list|queue|stack|vector|map|set|bitset|multiset|multimap|unordered_map|unordered_set|unordered_multiset|unordered_multimap|array)\\s*<",e:">",k:c,c:["self",e]},{b:t.IR+"::",k:c},{v:[{b:/=/,e:/;/},{b:/\(/,e:/\)/},{bK:"new throw return else",e:/;/}],k:c,c:n.concat([{b:/\(/,e:/\)/,k:c,c:n.concat(["self"]),r:0}]),r:0},{cN:"function",b:"("+t.IR+"[\\*&\\s]+)+"+a,rB:!0,e:/[{;=]/,eE:!0,k:c,i:/[^\w\s\*&]/,c:[{b:a,rB:!0,c:[t.TM],r:0},{cN:"params",b:/\(/,e:/\)/,k:c,r:0,c:[t.CLCM,t.CBCM,r,s,e]},t.CLCM,t.CBCM,i]}]),exports:{preprocessor:i,strings:r,k:c}}});hljs.registerLanguage("bash",function(e){var t={cN:"variable",v:[{b:/\$[\w\d#@][\w\d_]*/},{b:/\$\{(.*?)}/}]},s={cN:"string",b:/"/,e:/"/,c:[e.BE,t,{cN:"variable",b:/\$\(/,e:/\)/,c:[e.BE]}]},a={cN:"string",b:/'/,e:/'/};return{aliases:["sh","zsh"],l:/-?[a-z\._]+/,k:{keyword:"if then else elif fi for while in do done case esac function",literal:"true false",built_in:"break cd continue eval exec exit export getopts hash pwd readonly return shift test times trap umask unset alias bind builtin caller command declare echo enable help let local logout mapfile printf read readarray source type typeset ulimit unalias set shopt autoload bg bindkey bye cap chdir clone comparguments compcall compctl compdescribe compfiles compgroups compquote comptags comptry compvalues dirs disable disown echotc echoti emulate fc fg float functions getcap getln history integer jobs kill limit log noglob popd print pushd pushln rehash sched setcap setopt stat suspend ttyctl unfunction unhash unlimit unsetopt vared wait whence where which zcompile zformat zftp zle zmodload zparseopts zprof zpty zregexparse zsocket zstyle ztcp",_:"-ne -eq -lt -gt -f -d -e -s -l -a"},c:[{cN:"meta",b:/^#![^\n]+sh\s*$/,r:10},{cN:"function",b:/\w[\w\d_]*\s*\(\s*\)\s*\{/,rB:!0,c:[e.inherit(e.TM,{b:/\w[\w\d_]*/})],r:0},e.HCM,s,a,t]}});hljs.registerLanguage("json",function(e){var i={literal:"true false null"},n=[e.QSM,e.CNM],r={e:",",eW:!0,eE:!0,c:n,k:i},t={b:"{",e:"}",c:[{cN:"attr",b:/"/,e:/"/,c:[e.BE],i:"\\n"},e.inherit(r,{b:/:/})],i:"\\S"},c={b:"\\[",e:"\\]",c:[e.inherit(r)],i:"\\S"};return n.splice(n.length,0,t,c),{c:n,k:i,i:"\\S"}});hljs.registerLanguage("php",function(e){var c={b:"\\$+[a-zA-Z_-ÿ][a-zA-Z0-9_-ÿ]*"},i={cN:"meta",b:/<\?(php)?|\?>/},t={cN:"string",c:[e.BE,i],v:[{b:'b"',e:'"'},{b:"b'",e:"'"},e.inherit(e.ASM,{i:null}),e.inherit(e.QSM,{i:null})]},a={v:[e.BNM,e.CNM]};return{aliases:["php3","php4","php5","php6"],cI:!0,k:"and include_once list abstract global private echo interface as static endswitch array null if endwhile or const for endforeach self var while isset public protected exit foreach throw elseif include __FILE__ empty require_once do xor return parent clone use __CLASS__ __LINE__ else break print eval new catch __METHOD__ case exception default die require __FUNCTION__ enddeclare final try switch continue endfor endif declare unset true false trait goto instanceof insteadof __DIR__ __NAMESPACE__ yield finally",c:[e.HCM,e.C("//","$",{c:[i]}),e.C("/\\*","\\*/",{c:[{cN:"doctag",b:"@[A-Za-z]+"}]}),e.C("__halt_compiler.+?;",!1,{eW:!0,k:"__halt_compiler",l:e.UIR}),{cN:"string",b:/<<<['"]?\w+['"]?$/,e:/^\w+;?$/,c:[e.BE,{cN:"subst",v:[{b:/\$\w+/},{b:/\{\$/,e:/\}/}]}]},i,{cN:"keyword",b:/\$this\b/},c,{b:/(::|->)+[a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*/},{cN:"function",bK:"function",e:/[;{]/,eE:!0,i:"\\$|\\[|%",c:[e.UTM,{cN:"params",b:"\\(",e:"\\)",c:["self",c,e.CBCM,t,a]}]},{cN:"class",bK:"class interface",e:"{",eE:!0,i:/[:\(\$"]/,c:[{bK:"extends implements"},e.UTM]},{bK:"namespace",e:";",i:/[\.']/,c:[e.UTM]},{bK:"use",e:";",c:[e.UTM]},{b:"=>"},t,a]}});hljs.registerLanguage("ini",function(e){var b={cN:"string",c:[e.BE],v:[{b:"'''",e:"'''",r:10},{b:'"""',e:'"""',r:10},{b:'"',e:'"'},{b:"'",e:"'"}]};return{aliases:["toml"],cI:!0,i:/\S/,c:[e.C(";","$"),e.HCM,{cN:"section",b:/^\s*\[+/,e:/\]+/},{b:/^[a-z0-9\[\]_-]+\s*=\s*/,e:"$",rB:!0,c:[{cN:"attr",b:/[a-z0-9\[\]_-]+/},{b:/=/,eW:!0,r:0,c:[{cN:"literal",b:/\bon|off|true|false|yes|no\b/},{cN:"variable",v:[{b:/\$[\w\d"][\w\d_]*/},{b:/\$\{(.*?)}/}]},b,{cN:"number",b:/([\+\-]+)?[\d]+_[\d_]+/},e.NM]}]}]}});hljs.registerLanguage("java",function(e){var t=e.UIR+"(<"+e.UIR+"(\\s*,\\s*"+e.UIR+")*>)?",a="false synchronized int abstract float private char boolean static null if const for true while long strictfp finally protected import native final void enum else break transient catch instanceof byte super volatile case assert short package default double public try this switch continue throws protected public private module requires exports",r="\\b(0[bB]([01]+[01_]+[01]+|[01]+)|0[xX]([a-fA-F0-9]+[a-fA-F0-9_]+[a-fA-F0-9]+|[a-fA-F0-9]+)|(([\\d]+[\\d_]+[\\d]+|[\\d]+)(\\.([\\d]+[\\d_]+[\\d]+|[\\d]+))?|\\.([\\d]+[\\d_]+[\\d]+|[\\d]+))([eE][-+]?\\d+)?)[lLfF]?",s={cN:"number",b:r,r:0};return{aliases:["jsp"],k:a,i:/<\/|#/,c:[e.C("/\\*\\*","\\*/",{r:0,c:[{b:/\w+@/,r:0},{cN:"doctag",b:"@[A-Za-z]+"}]}),e.CLCM,e.CBCM,e.ASM,e.QSM,{cN:"class",bK:"class interface",e:/[{;=]/,eE:!0,k:"class interface",i:/[:"\[\]]/,c:[{bK:"extends implements"},e.UTM]},{bK:"new throw return else",r:0},{cN:"function",b:"("+t+"\\s+)+"+e.UIR+"\\s*\\(",rB:!0,e:/[{;=]/,eE:!0,k:a,c:[{b:e.UIR+"\\s*\\(",rB:!0,r:0,c:[e.UTM]},{cN:"params",b:/\(/,e:/\)/,k:a,r:0,c:[e.ASM,e.QSM,e.CNM,e.CBCM]},e.CLCM,e.CBCM]},s,{cN:"meta",b:"@[A-Za-z]+"}]}});hljs.registerLanguage("perl",function(e){var t="getpwent getservent quotemeta msgrcv scalar kill dbmclose undef lc ma syswrite tr send umask sysopen shmwrite vec qx utime local oct semctl localtime readpipe do return format read sprintf dbmopen pop getpgrp not getpwnam rewinddir qqfileno qw endprotoent wait sethostent bless s|0 opendir continue each sleep endgrent shutdown dump chomp connect getsockname die socketpair close flock exists index shmgetsub for endpwent redo lstat msgctl setpgrp abs exit select print ref gethostbyaddr unshift fcntl syscall goto getnetbyaddr join gmtime symlink semget splice x|0 getpeername recv log setsockopt cos last reverse gethostbyname getgrnam study formline endhostent times chop length gethostent getnetent pack getprotoent getservbyname rand mkdir pos chmod y|0 substr endnetent printf next open msgsnd readdir use unlink getsockopt getpriority rindex wantarray hex system getservbyport endservent int chr untie rmdir prototype tell listen fork shmread ucfirst setprotoent else sysseek link getgrgid shmctl waitpid unpack getnetbyname reset chdir grep split require caller lcfirst until warn while values shift telldir getpwuid my getprotobynumber delete and sort uc defined srand accept package seekdir getprotobyname semop our rename seek if q|0 chroot sysread setpwent no crypt getc chown sqrt write setnetent setpriority foreach tie sin msgget map stat getlogin unless elsif truncate exec keys glob tied closedirioctl socket readlink eval xor readline binmode setservent eof ord bind alarm pipe atan2 getgrent exp time push setgrent gt lt or ne m|0 break given say state when",r={cN:"subst",b:"[$@]\\{",e:"\\}",k:t},s={b:"->{",e:"}"},n={v:[{b:/\$\d/},{b:/[\$%@](\^\w\b|#\w+(::\w+)*|{\w+}|\w+(::\w*)*)/},{b:/[\$%@][^\s\w{]/,r:0}]},i=[e.BE,r,n],o=[n,e.HCM,e.C("^\\=\\w","\\=cut",{eW:!0}),s,{cN:"string",c:i,v:[{b:"q[qwxr]?\\s*\\(",e:"\\)",r:5},{b:"q[qwxr]?\\s*\\[",e:"\\]",r:5},{b:"q[qwxr]?\\s*\\{",e:"\\}",r:5},{b:"q[qwxr]?\\s*\\|",e:"\\|",r:5},{b:"q[qwxr]?\\s*\\<",e:"\\>",r:5},{b:"qw\\s+q",e:"q",r:5},{b:"'",e:"'",c:[e.BE]},{b:'"',e:'"'},{b:"`",e:"`",c:[e.BE]},{b:"{\\w+}",c:[],r:0},{b:"-?\\w+\\s*\\=\\>",c:[],r:0}]},{cN:"number",b:"(\\b0[0-7_]+)|(\\b0x[0-9a-fA-F_]+)|(\\b[1-9][0-9_]*(\\.[0-9_]+)?)|[0_]\\b",r:0},{b:"(\\/\\/|"+e.RSR+"|\\b(split|return|print|reverse|grep)\\b)\\s*",k:"split return print reverse grep",r:0,c:[e.HCM,{cN:"regexp",b:"(s|tr|y)/(\\\\.|[^/])*/(\\\\.|[^/])*/[a-z]*",r:10},{cN:"regexp",b:"(m|qr)?/",e:"/[a-z]*",c:[e.BE],r:0}]},{cN:"function",bK:"sub",e:"(\\s*\\(.*?\\))?[;{]",eE:!0,r:5,c:[e.TM]},{b:"-\\w\\b",r:0},{b:"^__DATA__$",e:"^__END__$",sL:"mojolicious",c:[{b:"^@@.*",e:"$",cN:"comment"}]}];return r.c=o,s.c=o,{aliases:["pl","pm"],l:/[\w\.]+/,k:t,c:o}});hljs.registerLanguage("cs",function(e){var i={keyword:"abstract as base bool break byte case catch char checked const continue decimal default delegate do double else enum event explicit extern finally fixed float for foreach goto if implicit in int interface internal is lock long object operator out override params private protected public readonly ref sbyte sealed short sizeof stackalloc static string struct switch this try typeof uint ulong unchecked unsafe ushort using virtual void volatile while nameof add alias ascending async await by descending dynamic equals from get global group into join let on orderby partial remove select set value var where yield",literal:"null false true"},r={cN:"string",b:'@"',e:'"',c:[{b:'""'}]},t=e.inherit(r,{i:/\n/}),a={cN:"subst",b:"{",e:"}",k:i},n=e.inherit(a,{i:/\n/}),c={cN:"string",b:/\$"/,e:'"',i:/\n/,c:[{b:"{{"},{b:"}}"},e.BE,n]},s={cN:"string",b:/\$@"/,e:'"',c:[{b:"{{"},{b:"}}"},{b:'""'},a]},o=e.inherit(s,{i:/\n/,c:[{b:"{{"},{b:"}}"},{b:'""'},n]});a.c=[s,c,r,e.ASM,e.QSM,e.CNM,e.CBCM],n.c=[o,c,t,e.ASM,e.QSM,e.CNM,e.inherit(e.CBCM,{i:/\n/})];var l={v:[s,c,r,e.ASM,e.QSM]},b=e.IR+"(<"+e.IR+"(\\s*,\\s*"+e.IR+")*>)?(\\[\\])?";return{aliases:["csharp"],k:i,i:/::/,c:[e.C("///","$",{rB:!0,c:[{cN:"doctag",v:[{b:"///",r:0},{b:"<!--|-->"},{b:"</?",e:">"}]}]}),e.CLCM,e.CBCM,{cN:"meta",b:"#",e:"$",k:{"meta-keyword":"if else elif endif define undef warning error line region endregion pragma checksum"}},l,e.CNM,{bK:"class interface",e:/[{;=]/,i:/[^\s:]/,c:[e.TM,e.CLCM,e.CBCM]},{bK:"namespace",e:/[{;=]/,i:/[^\s:]/,c:[e.inherit(e.TM,{b:"[a-zA-Z](\\.?\\w)*"}),e.CLCM,e.CBCM]},{bK:"new return throw await",r:0},{cN:"function",b:"("+b+"\\s+)+"+e.IR+"\\s*\\(",rB:!0,e:/[{;=]/,eE:!0,k:i,c:[{b:e.IR+"\\s*\\(",rB:!0,c:[e.TM],r:0},{cN:"params",b:/\(/,e:/\)/,eB:!0,eE:!0,k:i,r:0,c:[l,e.CNM,e.CBCM]},e.CLCM,e.CBCM]}]}});hljs.registerLanguage("apache",function(e){var r={cN:"number",b:"[\\$%]\\d+"};return{aliases:["apacheconf"],cI:!0,c:[e.HCM,{cN:"section",b:"</?",e:">"},{cN:"attribute",b:/\w+/,r:0,k:{nomarkup:"order deny allow setenv rewriterule rewriteengine rewritecond documentroot sethandler errordocument loadmodule options header listen serverroot servername"},starts:{e:/$/,r:0,k:{literal:"on off all"},c:[{cN:"meta",b:"\\s\\[",e:"\\]$"},{cN:"variable",b:"[\\$%]\\{",e:"\\}",c:["self",r]},r,e.QSM]}}],i:/\S/}});hljs.registerLanguage("nginx",function(e){var r={cN:"variable",v:[{b:/\$\d+/},{b:/\$\{/,e:/}/},{b:"[\\$\\@]"+e.UIR}]},b={eW:!0,l:"[a-z/_]+",k:{literal:"on off yes no true false none blocked debug info notice warn error crit select break last permanent redirect kqueue rtsig epoll poll /dev/poll"},r:0,i:"=>",c:[e.HCM,{cN:"string",c:[e.BE,r],v:[{b:/"/,e:/"/},{b:/'/,e:/'/}]},{b:"([a-z]+):/",e:"\\s",eW:!0,eE:!0,c:[r]},{cN:"regexp",c:[e.BE,r],v:[{b:"\\s\\^",e:"\\s|{|;",rE:!0},{b:"~\\*?\\s+",e:"\\s|{|;",rE:!0},{b:"\\*(\\.[a-z\\-]+)+"},{b:"([a-z\\-]+\\.)+\\*"}]},{cN:"number",b:"\\b\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}(:\\d{1,5})?\\b"},{cN:"number",b:"\\b\\d+[kKmMgGdshdwy]*\\b",r:0},r]};return{aliases:["nginxconf"],c:[e.HCM,{b:e.UIR+"\\s+{",rB:!0,e:"{",c:[{cN:"section",b:e.UIR}],r:0},{b:e.UIR+"\\s",e:";|{",rB:!0,c:[{cN:"attribute",b:e.UIR,starts:b}],r:0}],i:"[^\\s\\}]"}});hljs.registerLanguage("coffeescript",function(e){var c={keyword:"in if for while finally new do return else break catch instanceof throw try this switch continue typeof delete debugger super then unless until loop of by when and or is isnt not",literal:"true false null undefined yes no on off",built_in:"npm require console print module global window document"},n="[A-Za-z$_][0-9A-Za-z$_]*",r={cN:"subst",b:/#\{/,e:/}/,k:c},s=[e.BNM,e.inherit(e.CNM,{starts:{e:"(\\s*/)?",r:0}}),{cN:"string",v:[{b:/'''/,e:/'''/,c:[e.BE]},{b:/'/,e:/'/,c:[e.BE]},{b:/"""/,e:/"""/,c:[e.BE,r]},{b:/"/,e:/"/,c:[e.BE,r]}]},{cN:"regexp",v:[{b:"///",e:"///",c:[r,e.HCM]},{b:"//[gim]*",r:0},{b:/\/(?![ *])(\\\/|.)*?\/[gim]*(?=\W|$)/}]},{b:"@"+n},{b:"`",e:"`",eB:!0,eE:!0,sL:"javascript"}];r.c=s;var i=e.inherit(e.TM,{b:n}),t="(\\(.*\\))?\\s*\\B[-=]>",o={cN:"params",b:"\\([^\\(]",rB:!0,c:[{b:/\(/,e:/\)/,k:c,c:["self"].concat(s)}]};return{aliases:["coffee","cson","iced"],k:c,i:/\/\*/,c:s.concat([e.C("###","###"),e.HCM,{cN:"function",b:"^\\s*"+n+"\\s*=\\s*"+t,e:"[-=]>",rB:!0,c:[i,o]},{b:/[:\(,=]\s*/,r:0,c:[{cN:"function",b:t,e:"[-=]>",rB:!0,c:[o]}]},{cN:"class",bK:"class",e:"$",i:/[:="\[\]]/,c:[{bK:"extends",eW:!0,i:/[:="\[\]]/,c:[i]},i]},{b:n+":",e:":",rB:!0,rE:!0,r:0}])}});hljs.registerLanguage("diff",function(e){return{aliases:["patch"],c:[{cN:"meta",r:10,v:[{b:/^@@ +\-\d+,\d+ +\+\d+,\d+ +@@$/},{b:/^\*\*\* +\d+,\d+ +\*\*\*\*$/},{b:/^\-\-\- +\d+,\d+ +\-\-\-\-$/}]},{cN:"comment",v:[{b:/Index: /,e:/$/},{b:/={3,}/,e:/$/},{b:/^\-{3}/,e:/$/},{b:/^\*{3} /,e:/$/},{b:/^\+{3}/,e:/$/},{b:/\*{5}/,e:/\*{5}$/}]},{cN:"addition",b:"^\\+",e:"$"},{cN:"deletion",b:"^\\-",e:"$"},{cN:"addition",b:"^\\!",e:"$"}]}});hljs.registerLanguage("sql",function(e){var t=e.C("--","$");return{cI:!0,i:/[<>{}*#]/,c:[{bK:"begin end start commit rollback savepoint lock alter create drop rename call delete do handler insert load replace select truncate update set show pragma grant merge describe use explain help declare prepare execute deallocate release unlock purge reset change stop analyze cache flush optimize repair kill install uninstall checksum restore check backup revoke comment",e:/;/,eW:!0,l:/[\w\.]+/,k:{keyword:"abort abs absolute acc acce accep accept access accessed accessible account acos action activate add addtime admin administer advanced advise aes_decrypt aes_encrypt after agent aggregate ali alia alias allocate allow alter always analyze ancillary and any anydata anydataset anyschema anytype apply archive archived archivelog are as asc ascii asin assembly assertion associate asynchronous at atan atn2 attr attri attrib attribu attribut attribute attributes audit authenticated authentication authid authors auto autoallocate autodblink autoextend automatic availability avg backup badfile basicfile before begin beginning benchmark between bfile bfile_base big bigfile bin binary_double binary_float binlog bit_and bit_count bit_length bit_or bit_xor bitmap blob_base block blocksize body both bound buffer_cache buffer_pool build bulk by byte byteordermark bytes cache caching call calling cancel capacity cascade cascaded case cast catalog category ceil ceiling chain change changed char_base char_length character_length characters characterset charindex charset charsetform charsetid check checksum checksum_agg child choose chr chunk class cleanup clear client clob clob_base clone close cluster_id cluster_probability cluster_set clustering coalesce coercibility col collate collation collect colu colum column column_value columns columns_updated comment commit compact compatibility compiled complete composite_limit compound compress compute concat concat_ws concurrent confirm conn connec connect connect_by_iscycle connect_by_isleaf connect_by_root connect_time connection consider consistent constant constraint constraints constructor container content contents context contributors controlfile conv convert convert_tz corr corr_k corr_s corresponding corruption cos cost count count_big counted covar_pop covar_samp cpu_per_call cpu_per_session crc32 create creation critical cross cube cume_dist curdate current current_date current_time current_timestamp current_user cursor curtime customdatum cycle data database databases datafile datafiles datalength date_add date_cache date_format date_sub dateadd datediff datefromparts datename datepart datetime2fromparts day day_to_second dayname dayofmonth dayofweek dayofyear days db_role_change dbtimezone ddl deallocate declare decode decompose decrement decrypt deduplicate def defa defau defaul default defaults deferred defi defin define degrees delayed delegate delete delete_all delimited demand dense_rank depth dequeue des_decrypt des_encrypt des_key_file desc descr descri describ describe descriptor deterministic diagnostics difference dimension direct_load directory disable disable_all disallow disassociate discardfile disconnect diskgroup distinct distinctrow distribute distributed div do document domain dotnet double downgrade drop dumpfile duplicate duration each edition editionable editions element ellipsis else elsif elt empty enable enable_all enclosed encode encoding encrypt end end-exec endian enforced engine engines enqueue enterprise entityescaping eomonth error errors escaped evalname evaluate event eventdata events except exception exceptions exchange exclude excluding execu execut execute exempt exists exit exp expire explain export export_set extended extent external external_1 external_2 externally extract failed failed_login_attempts failover failure far fast feature_set feature_value fetch field fields file file_name_convert filesystem_like_logging final finish first first_value fixed flash_cache flashback floor flush following follows for forall force form forma format found found_rows freelist freelists freepools fresh from from_base64 from_days ftp full function general generated get get_format get_lock getdate getutcdate global global_name globally go goto grant grants greatest group group_concat group_id grouping grouping_id groups gtid_subtract guarantee guard handler hash hashkeys having hea head headi headin heading heap help hex hierarchy high high_priority hosts hour http id ident_current ident_incr ident_seed identified identity idle_time if ifnull ignore iif ilike ilm immediate import in include including increment index indexes indexing indextype indicator indices inet6_aton inet6_ntoa inet_aton inet_ntoa infile initial initialized initially initrans inmemory inner innodb input insert install instance instantiable instr interface interleaved intersect into invalidate invisible is is_free_lock is_ipv4 is_ipv4_compat is_not is_not_null is_used_lock isdate isnull isolation iterate java join json json_exists keep keep_duplicates key keys kill language large last last_day last_insert_id last_value lax lcase lead leading least leaves left len lenght length less level levels library like like2 like4 likec limit lines link list listagg little ln load load_file lob lobs local localtime localtimestamp locate locator lock locked log log10 log2 logfile logfiles logging logical logical_reads_per_call logoff logon logs long loop low low_priority lower lpad lrtrim ltrim main make_set makedate maketime managed management manual map mapping mask master master_pos_wait match matched materialized max maxextents maximize maxinstances maxlen maxlogfiles maxloghistory maxlogmembers maxsize maxtrans md5 measures median medium member memcompress memory merge microsecond mid migration min minextents minimum mining minus minute minvalue missing mod mode model modification modify module monitoring month months mount move movement multiset mutex name name_const names nan national native natural nav nchar nclob nested never new newline next nextval no no_write_to_binlog noarchivelog noaudit nobadfile nocheck nocompress nocopy nocycle nodelay nodiscardfile noentityescaping noguarantee nokeep nologfile nomapping nomaxvalue nominimize nominvalue nomonitoring none noneditionable nonschema noorder nopr nopro noprom nopromp noprompt norely noresetlogs noreverse normal norowdependencies noschemacheck noswitch not nothing notice notrim novalidate now nowait nth_value nullif nulls num numb numbe nvarchar nvarchar2 object ocicoll ocidate ocidatetime ociduration ociinterval ociloblocator ocinumber ociref ocirefcursor ocirowid ocistring ocitype oct octet_length of off offline offset oid oidindex old on online only opaque open operations operator optimal optimize option optionally or oracle oracle_date oradata ord ordaudio orddicom orddoc order ordimage ordinality ordvideo organization orlany orlvary out outer outfile outline output over overflow overriding package pad parallel parallel_enable parameters parent parse partial partition partitions pascal passing password password_grace_time password_lock_time password_reuse_max password_reuse_time password_verify_function patch path patindex pctincrease pctthreshold pctused pctversion percent percent_rank percentile_cont percentile_disc performance period period_add period_diff permanent physical pi pipe pipelined pivot pluggable plugin policy position post_transaction pow power pragma prebuilt precedes preceding precision prediction prediction_cost prediction_details prediction_probability prediction_set prepare present preserve prior priority private private_sga privileges procedural procedure procedure_analyze processlist profiles project prompt protection public publishingservername purge quarter query quick quiesce quota quotename radians raise rand range rank raw read reads readsize rebuild record records recover recovery recursive recycle redo reduced ref reference referenced references referencing refresh regexp_like register regr_avgx regr_avgy regr_count regr_intercept regr_r2 regr_slope regr_sxx regr_sxy reject rekey relational relative relaylog release release_lock relies_on relocate rely rem remainder rename repair repeat replace replicate replication required reset resetlogs resize resource respect restore restricted result result_cache resumable resume retention return returning returns reuse reverse revoke right rlike role roles rollback rolling rollup round row row_count rowdependencies rowid rownum rows rtrim rules safe salt sample save savepoint sb1 sb2 sb4 scan schema schemacheck scn scope scroll sdo_georaster sdo_topo_geometry search sec_to_time second section securefile security seed segment select self sequence sequential serializable server servererror session session_user sessions_per_user set sets settings sha sha1 sha2 share shared shared_pool short show shrink shutdown si_averagecolor si_colorhistogram si_featurelist si_positionalcolor si_stillimage si_texture siblings sid sign sin size size_t sizes skip slave sleep smalldatetimefromparts smallfile snapshot some soname sort soundex source space sparse spfile split sql sql_big_result sql_buffer_result sql_cache sql_calc_found_rows sql_small_result sql_variant_property sqlcode sqldata sqlerror sqlname sqlstate sqrt square standalone standby start starting startup statement static statistics stats_binomial_test stats_crosstab stats_ks_test stats_mode stats_mw_test stats_one_way_anova stats_t_test_ stats_t_test_indep stats_t_test_one stats_t_test_paired stats_wsr_test status std stddev stddev_pop stddev_samp stdev stop storage store stored str str_to_date straight_join strcmp strict string struct stuff style subdate subpartition subpartitions substitutable substr substring subtime subtring_index subtype success sum suspend switch switchoffset switchover sync synchronous synonym sys sys_xmlagg sysasm sysaux sysdate sysdatetimeoffset sysdba sysoper system system_user sysutcdatetime table tables tablespace tan tdo template temporary terminated tertiary_weights test than then thread through tier ties time time_format time_zone timediff timefromparts timeout timestamp timestampadd timestampdiff timezone_abbr timezone_minute timezone_region to to_base64 to_date to_days to_seconds todatetimeoffset trace tracking transaction transactional translate translation treat trigger trigger_nestlevel triggers trim truncate try_cast try_convert try_parse type ub1 ub2 ub4 ucase unarchived unbounded uncompress under undo unhex unicode uniform uninstall union unique unix_timestamp unknown unlimited unlock unpivot unrecoverable unsafe unsigned until untrusted unusable unused update updated upgrade upped upper upsert url urowid usable usage use use_stored_outlines user user_data user_resources users using utc_date utc_timestamp uuid uuid_short validate validate_password_strength validation valist value values var var_samp varcharc vari varia variab variabl variable variables variance varp varraw varrawc varray verify version versions view virtual visible void wait wallet warning warnings week weekday weekofyear wellformed when whene whenev wheneve whenever where while whitespace with within without work wrapped xdb xml xmlagg xmlattributes xmlcast xmlcolattval xmlelement xmlexists xmlforest xmlindex xmlnamespaces xmlpi xmlquery xmlroot xmlschema xmlserialize xmltable xmltype xor year year_to_month years yearweek",literal:"true false null",built_in:"array bigint binary bit blob boolean char character date dec decimal float int int8 integer interval number numeric real record serial serial8 smallint text varchar varying void"},c:[{cN:"string",b:"'",e:"'",c:[e.BE,{b:"''"}]},{cN:"string",b:'"',e:'"',c:[e.BE,{b:'""'}]},{cN:"string",b:"`",e:"`",c:[e.BE]},e.CNM,e.CBCM,t]},e.CBCM,t]}});hljs.registerLanguage("http",function(e){var t="HTTP/[0-9\\.]+";return{aliases:["https"],i:"\\S",c:[{b:"^"+t,e:"$",c:[{cN:"number",b:"\\b\\d{3}\\b"}]},{b:"^[A-Z]+ (.*?) "+t+"$",rB:!0,e:"$",c:[{cN:"string",b:" ",e:" ",eB:!0,eE:!0},{b:t},{cN:"keyword",b:"[A-Z]+"}]},{cN:"attribute",b:"^\\w",e:": ",eE:!0,i:"\\n|\\s|=",starts:{e:"$",r:0}},{b:"\\n\\n",starts:{sL:[],eW:!0}}]}});hljs.registerLanguage("javascript",function(e){var r="[A-Za-z$_][0-9A-Za-z$_]*",t={keyword:"in of if for while finally var new function do return void else break catch instanceof with throw case default try this switch continue typeof delete let yield const export super debugger as async await static import from as",literal:"true false null undefined NaN Infinity",built_in:"eval isFinite isNaN parseFloat parseInt decodeURI decodeURIComponent encodeURI encodeURIComponent escape unescape Object Function Boolean Error EvalError InternalError RangeError ReferenceError StopIteration SyntaxError TypeError URIError Number Math Date String RegExp Array Float32Array Float64Array Int16Array Int32Array Int8Array Uint16Array Uint32Array Uint8Array Uint8ClampedArray ArrayBuffer DataView JSON Intl arguments require module console window document Symbol Set Map WeakSet WeakMap Proxy Reflect Promise"},a={cN:"number",v:[{b:"\\b(0[bB][01]+)"},{b:"\\b(0[oO][0-7]+)"},{b:e.CNR}],r:0},n={cN:"subst",b:"\\$\\{",e:"\\}",k:t,c:[]},c={cN:"string",b:"`",e:"`",c:[e.BE,n]};n.c=[e.ASM,e.QSM,c,a,e.RM];var s=n.c.concat([e.CBCM,e.CLCM]);return{aliases:["js","jsx"],k:t,c:[{cN:"meta",r:10,b:/^\s*['"]use (strict|asm)['"]/},{cN:"meta",b:/^#!/,e:/$/},e.ASM,e.QSM,c,e.CLCM,e.CBCM,a,{b:/[{,]\s*/,r:0,c:[{b:r+"\\s*:",rB:!0,r:0,c:[{cN:"attr",b:r,r:0}]}]},{b:"("+e.RSR+"|\\b(case|return|throw)\\b)\\s*",k:"return throw case",c:[e.CLCM,e.CBCM,e.RM,{cN:"function",b:"(\\(.*?\\)|"+r+")\\s*=>",rB:!0,e:"\\s*=>",c:[{cN:"params",v:[{b:r},{b:/\(\s*\)/},{b:/\(/,e:/\)/,eB:!0,eE:!0,k:t,c:s}]}]},{b:/</,e:/(\/\w+|\w+\/)>/,sL:"xml",c:[{b:/<\w+\s*\/>/,skip:!0},{b:/<\w+/,e:/(\/\w+|\w+\/)>/,skip:!0,c:[{b:/<\w+\s*\/>/,skip:!0},"self"]}]}],r:0},{cN:"function",bK:"function",e:/\{/,eE:!0,c:[e.inherit(e.TM,{b:r}),{cN:"params",b:/\(/,e:/\)/,eB:!0,eE:!0,c:s}],i:/\[|%/},{b:/\$[(.]/},e.METHOD_GUARD,{cN:"class",bK:"class",e:/[{;=]/,eE:!0,i:/[:"\[\]]/,c:[{bK:"extends"},e.UTM]},{bK:"constructor",e:/\{/,eE:!0}],i:/#(?!!)/}});hljs.registerLanguage("objectivec",function(e){var t={cN:"built_in",b:"\\b(AV|CA|CF|CG|CI|CL|CM|CN|CT|MK|MP|MTK|MTL|NS|SCN|SK|UI|WK|XC)\\w+"},_={keyword:"int float while char export sizeof typedef const struct for union unsigned long volatile static bool mutable if do return goto void enum else break extern asm case short default double register explicit signed typename this switch continue wchar_t inline readonly assign readwrite self @synchronized id typeof nonatomic super unichar IBOutlet IBAction strong weak copy in out inout bycopy byref oneway __strong __weak __block __autoreleasing @private @protected @public @try @property @end @throw @catch @finally @autoreleasepool @synthesize @dynamic @selector @optional @required @encode @package @import @defs @compatibility_alias __bridge __bridge_transfer __bridge_retained __bridge_retain __covariant __contravariant __kindof _Nonnull _Nullable _Null_unspecified __FUNCTION__ __PRETTY_FUNCTION__ __attribute__ getter setter retain unsafe_unretained nonnull nullable null_unspecified null_resettable class instancetype NS_DESIGNATED_INITIALIZER NS_UNAVAILABLE NS_REQUIRES_SUPER NS_RETURNS_INNER_POINTER NS_INLINE NS_AVAILABLE NS_DEPRECATED NS_ENUM NS_OPTIONS NS_SWIFT_UNAVAILABLE NS_ASSUME_NONNULL_BEGIN NS_ASSUME_NONNULL_END NS_REFINED_FOR_SWIFT NS_SWIFT_NAME NS_SWIFT_NOTHROW NS_DURING NS_HANDLER NS_ENDHANDLER NS_VALUERETURN NS_VOIDRETURN",literal:"false true FALSE TRUE nil YES NO NULL",built_in:"BOOL dispatch_once_t dispatch_queue_t dispatch_sync dispatch_async dispatch_once"},i=/[a-zA-Z@][a-zA-Z0-9_]*/,n="@interface @class @protocol @implementation";return{aliases:["mm","objc","obj-c"],k:_,l:i,i:"</",c:[t,e.CLCM,e.CBCM,e.CNM,e.QSM,{cN:"string",v:[{b:'@"',e:'"',i:"\\n",c:[e.BE]},{b:"'",e:"[^\\\\]'",i:"[^\\\\][^']"}]},{cN:"meta",b:"#",e:"$",c:[{cN:"meta-string",v:[{b:'"',e:'"'},{b:"<",e:">"}]}]},{cN:"class",b:"("+n.split(" ").join("|")+")\\b",e:"({|$)",eE:!0,k:n,l:i,c:[e.UTM]},{b:"\\."+e.UIR,r:0}]}});

/**
* MarkUtil - A Lib for Shouqu article note
* Author: wei.shi@shouqu.me
* Update: 2016-07-25
* Version: 0.1
*/
(function($){
	var MarkUtil = {

		//默认高亮类名
		"activeClassName" : navigator.userAgent.match(/Android/i) == null ? "mark-text" : "mark-text-alter",

		//设置高亮类名
		"setActiveClassName" : function(className){
			MarkUtil.activeClassName = className;
		},

		//设置注释类名
		"commentClassName" : "comment-icon",

		//默认文本节点类名
		"markSpanClassName" : "sqt",

		//设置默认文本节点类名
		"setMarkSpanClassName" : function(className){
			MarkUtil.markSpanClassName = className;
		},

		//数据格式版本号，默认为2
		"dataFormatVersion" : 1,//默认在common中设置，新加书签均为2，此处都设置为1

		//设置数据格式版本号
		"setDataFormatVersion" : function(ver){
			MarkUtil.dataFormatVersion = ver;
		},

		//系统版本号
		"osVer" : 1,
		//系统类型号
		"osType" : "android",
		//应用版本号
		"appVer" : 144,
		
		//设置系统版本
		"setOsVer" : function(intVer){
			MarkUtil.osVer = intVer;
		},
		
		//设置系统类型
		"setOsType" : function(strType){
			MarkUtil.osType = strType;
		},
		
		//设置应用版本号
		"setAppVer" : function(intVer){
			MarkUtil.appVer = intVer;
		},

		//遍历DOM
		'traverseDOM' : function(node, func){
			func(node);
			node = node.firstChild;
			while (node) {
				MarkUtil.traverseDOM(node, func);
				node = node.nextSibling;
			}
		},

		//获取一个文本节点或元素节点在其父节点中的索引
		'getNodeIndexInParentElement' : function(oNode){
			var index = -1;
			var oParentNode = oNode.parentNode;
			for(var i = 0,len = oParentNode.childNodes.length; i < len; i++){
				if(oNode == oParentNode.childNodes[i]){
					index = i;
					break;
				}
			}
			return index;
		},

		//获取一个节点元素在所有同类型节点中的索引，如果是文本节点则返回其父节点的索引
		'getElementIndexOfTagName':function(oNode){

			var index = -1;
			var node = ( oNode.nodeType == document.TEXT_NODE ? oNode.parentNode : oNode );
			var tagName = node.tagName;

			var allTags = document.getElementsByTagName(tagName),len = allTags.length;
			for( var i = 0;i < len; i++ ){
				if(allTags[i] === node){
					index = i;
					break;
				}
			}
			return index;
		},

		//根据index和tagName 获取元素节点
		'getElementByTagNameIndex':function (tag_name,index){

			var all = document.getElementsByTagName(tag_name);
			var ele = null;
			for(var i = 0, len = all.length; i < len; i++){
				if(i == index){
					ele = all[i];
					break;
				}
			}
			return ele;
		},

		//获取一个元素节点在dom中的index值
		'getNodeIndexInDOM' : function(oNode){
			for(var i in document.all){
				if(document.all[i] == oNode){
					return +i;
				}
			}
		},

		//是否包含文本节点
		'hasTextNode' : function(oNode){
			if(oNode.nodeType != document.ELEMENT_NODE || oNode.childNodes.length  == 0){
				return false;
			}
			var ret = false;
			var children = oNode.childNodes;
			for(var i = 0; i < children.length; i++){
				if(children[i].nodeType == document.TEXT_NODE){
					ret = true;
					break;
				}
			}
			return ret;
		},

		//是否包含标记文本节点
		'hasMarkNode' : function(oNode){
			if(oNode.nodeType != document.ELEMENT_NODE || oNode.childNodes.length  == 0){
				return false;
			}
			var ret = false;
			var children = oNode.childNodes;
			for(var i = 0; i < children.length; i++){
				if(children[i].nodeType == document.ELEMENT_NODE && children[i].className.match(MarkUtil.markSpanClassName) != null){
					ret = true;
					break;
				}
			}
			return ret;
		},

		//根据index返回一个标记节点
		'getMarkNodeByIndex': function(index){
			return document.getElementsByClassName(MarkUtil.markSpanClassName).item(index);
		},

		//返回一个节点内的标记文本节点
		'getMarkChildren' : function(oNode){

			if(oNode.nodeType != document.ELEMENT_NODE || oNode.childNodes.length  == 0){
				return false;
			}
			var children = oNode.childNodes;
			var ret = [];
			for(var i = 0; i < children.length; i++){
				if(children[i].nodeType == document.ELEMENT_NODE && children[i].className.match(MarkUtil.markSpanClassName) != null){
					ret = true;
					break;
				}
			}
		},

		//获取一个元素在同一类中的index
		'getElementIndexOfClassName' : function(ele,clsName){

			//传入的ele必须是元素节点对象
			if(ele.nodeType != document.ELEMENT_NODE || typeof clsName != 'string'){
				console.log("错误的节点类型");
				return false;
			}

			//元素不具有类名时返回-1
			if(ele.className.match(clsName) == null){
				return -1;
			}

			//遍历所有同类
			var arr = document.getElementsByClassName(clsName);
			//var arr = $("." + clsName);
			for(var i = 0; i < arr.length; i += 1){
				if(arr[i] === ele){
					return i;
				}
			}
		},

		//返回一个元素节点内的直接文本子节点
		//recursive是否递归子节点
		'getTextNodes':function(node,recursive){
			var res = [];
			if(typeof(node) == 'undefined'){
				node = document.body;
			}
			if(typeof(recursive) == 'undefined'){
				recursive = false;
			}
			for(var i = 0,len = node.childNodes.length;i < len; i++){
				if(node.childNodes[i].nodeType == 3){
					res.push(node.childNodes[i]);
				}
			}
			if(recursive){
				MarkUtil.traverseDOM(node,function(n){
					if(n.nodeType == 3){
						res.push(n);
						//console.log(n);
					}
				});
			}
			return res;
		},

		//加载高亮数据，objBookmarkData是当前书签的高亮数据json对象，其中的notes保存了各个高亮部分的数据
		"loadMarkData" : function(objBookmarkData){

			//console.log("loading mark data...",objBookmarkData);
			if(typeof objBookmarkData == "object" && objBookmarkData.notes ){

				//对于包含数据版本信息的，将数据版本号存入当前MarkUtil属性，以备后用
				if( objBookmarkData.dataVersion ){
					MarkUtil.setDataFormatVersion(objBookmarkData.dataVersion);
				}

				//解析高亮数据
				MarkUtil.addMarks(objBookmarkData.notes);

			}else{
				console.log("传入的数据格式有误");
			}

		},

		//根据高亮数组添加效果，arrMarkData就是当前书签笔记数据对象的notes部分
		"addMarks":function(arrMarkData){

			if(arrMarkData.length > 0){

				_.each(arrMarkData,function(ele,idx){

					//获取所有标记类标签
					var $t = $("." + MarkUtil.markSpanClassName);
					var noteID = ele.noteID;


					//遍历每个note中的selection数组,找到对应的标记类span，添加高亮
					_.each(ele.selections,function(e,idx){

						//给span.t的文本节点包裹高亮span标签,但需要排除没有文本节点的元素节点，例如<span class="sqt"></span>
						if(e.tIndex != -1){
							var node = $t.get(e.tIndex);

							//！！！！分享出去的页面上存在位置偏移，此处的偏移量为2，如果将来分享页面有变化，此处可能会需要调整
							//另外ios下旧笔记数据在安卓系统上也可能产生2个位移的偏差，但此处暂不处理
							// if($("body").hasClass("origin") && window.location.href.match(/http/i) != null && MarkUtil.sysType == "ios"){
								// node = $t.get(e.tIndex - 2);
							// }
							// if(window.location.href.match(/http/i == null) && window.navigator.userAgent.match(/Android/i) != null && MarkUtil.sysType == "ios"){
								// node = $t.get(e.tIndex - 2);
							// }
							// if(window.location.href.match(/http/i == null) && window.navigator.userAgent.match(/iPhone|iPad|iPod/i) != null && MarkUtil.sysType == "android"){
								// node = $t.get(e.tIndex + 2);
							// }

							if(node.childNodes.length == 1 && node.childNodes[0].nodeType == 3){
								if(MarkUtil.dataFormatVersion == 2){
									MarkUtil.addMarkV2(node.childNodes[0],e.startOffset,e.endOffset,noteID);
								}else{
									MarkUtil.addMark(node.childNodes[0],e.startOffset,e.endOffset,noteID);
								}

							}
						}

					});

					//如果note中有注释则添加注释按钮
					//！注意：此处代码必须在高亮效果执行显示后才能正确执行
					if(typeof(ele.comment) != 'undefined' && ele.comment.length > 0){
						MarkUtil.addComment(noteID);
					}


				});
			}
		},

		//给指定节点内的文本节点从起始位置到终止位置添加标记,oNode必须为为文本节点
		'addMark':function (oNode,startOffset,endOffset,noteID){

			//检查数据合法性，排除非文本节点
			if(oNode.nodeValue == null || oNode.nodeType != 3){
				return false;
			}

			//设置高亮选区
			var range = document.createRange();

			range.setStart(oNode,startOffset);
			range.setEnd(oNode,endOffset);

			var span = document.createElement('span');
			span.setAttribute('class',MarkUtil.activeClassName);
			span.setAttribute('data-noteid',noteID);

			//给高亮部分添加ID属性，但只能添加一个
			var spanWithNoteID = document.getElementById(noteID);
			if(spanWithNoteID == null){
				//span.setAttribute("id", noteID);
			}
			range.surroundContents(span);

			//清除所有选中区域，将selection置为none
			window.getSelection().removeAllRanges();

		},

		//v2版addMark方法
		"addMarkV2" : function(oNode,startOffset,endOffset,noteID){

			//检查数据合法性，排除非文本节点
			if(oNode.nodeValue == null || oNode.nodeType != 3){
				return false;
			}

			//设置高亮选区
			var range = document.createRange();

			range.setStart(oNode,startOffset);
			range.setEnd(oNode,endOffset);

			var span = document.createElement('span');
			span.setAttribute('class',MarkUtil.activeClassName);
			span.setAttribute('data-noteid',noteID);

			//给高亮部分添加ID属性，但只能添加一个
			var spanWithNoteID = document.getElementById(noteID);
			if(spanWithNoteID == null){
				//span.setAttribute("id", noteID);
			}
			range.surroundContents(span);

			////V2版新增代码////
			//对选中文字高亮后处于同一文本节点内的剩余文本进行处理，包裹成新的标记类标签，不管文本内容是否为空
			try{

				var children = range.commonAncestorContainer.childNodes;
				for(var i = 0; i < children.length; i++){

					if(children[i].nodeType == document.TEXT_NODE){
						var range = document.createRange();
						var spanMark = document.createElement('span');
						spanMark.setAttribute('class',MarkUtil.markSpanClassName);
						range.selectNode(children[i]);
						range.surroundContents(spanMark);
					}

				}

			}catch(err){
				console.log(err.name + " : " + err.message);
			}

			//清除所有选中区域，将selection置为none
			window.getSelection().removeAllRanges();

		},

		//给指定节点添加注释
		"addComment" : function(noteID){
			//alert("添加注释：noteID" + noteID);
			var $note = $("." + MarkUtil.activeClassName + "[data-noteid='" + noteID + "']");
			if($note.last().next(".comment-icon").length == 0 ){
				$note.last().after('<i class="comment-icon" data-noteid="'+ noteID +'"><b>...</b></i>');
			}

		},

		//获取选中区域文本的起止数据
		"getSelectionData" : function(objSelection){

			var selection = typeof objSelection == "undefined" ? window.getSelection() : objSelection;

			var range = document.createRange();
			var $tClass = $("." + MarkUtil.markSpanClassName);
			var selectionData = [];

			var direction = 1;//选取文字方向，1：正向，-1：反向

			var startNodeIndex = MarkUtil.getElementIndexOfClassName(selection.anchorNode.parentElement,MarkUtil.markSpanClassName);
			var endNodeIndex = MarkUtil.getElementIndexOfClassName(selection.focusNode.parentElement,MarkUtil.markSpanClassName);

			//打印起止文本节点tIndex
			console.log("start tIndex:",startNodeIndex);
			console.log("end tIndex:", endNodeIndex);

			//当反向选择时，交换起止节点
			if(startNodeIndex > endNodeIndex){
				direction = -1;
				var t = startNodeIndex;
				startNodeIndex = endNodeIndex;
				endNodeIndex = t;

			}


			//按是否跨节点，分为两种情况
			if(startNodeIndex == endNodeIndex){

				//当不跨节点时，选择文字都位于同一个t标签内时
				data = {
					"tIndex" : startNodeIndex,
					"startOffset" : (selection.anchorOffset < selection.focusOffset) ? selection.anchorOffset : selection.focusOffset,
					"endOffset" : (selection.anchorOffset < selection.focusOffset) ? selection.focusOffset : selection.anchorOffset
				}
				selectionData.push(data);
			}else{

				//当跨节点时，可能会出现跨2个节点和跨3个节点以上的情况，循环起止节点
				//已知问题：过渡node中不包含任何文本节点时，调用node.childNodes[0]会出错，此情况已在addMarks方法中做了排除
				//当anchorNode或focusNode不是文本节点时，调用nodeValue.length时会出错，例如包含图片的a标签，恰好选到图片下一段文字之前时，focusNode为下一段文字的元素节点
				if(direction == 1){

					for(var i = startNodeIndex ; i <= endNodeIndex; i += 1){


						if(i == startNodeIndex){ //起始节点

							data = {
								"tIndex" : i,
								"startOffset" : selection.anchorOffset,
								"endOffset" : selection.anchorNode.nodeValue.length//$tClass.get(i).childNodes[0].nodeValue.length//
							};
						}else if(i == endNodeIndex){ //终止节点
							data = {
								"tIndex" : i,
								"startOffset" : 0,
								"endOffset" : selection.focusOffset
							};
						}else{ //其他过渡节点
							data = {
								"tIndex" : i,
								"startOffset" : 0,
								"endOffset" : $tClass.get(i).childNodes[0].nodeValue.length//$tClass.get(i).innerText.length//
							};
						}
						selectionData.push(data);
					}

				}else if(direction == -1){

					for(var i = startNodeIndex ; i <= endNodeIndex; i += 1){
						if(i == startNodeIndex){
							data = {
								"tIndex" : i,
								"startOffset" : selection.focusOffset,
								"endOffset" : $tClass.get(i).childNodes[0].nodeValue.length//selection.focusNode.nodeValue.length //
							};
						}else if(i == endNodeIndex){
							data = {
								"tIndex" : i,
								"startOffset" : 0,
								"endOffset" : selection.anchorOffset
							};
						}else{
							data = {
								"tIndex" : i,
								"startOffset" : 0,
								"endOffset" : $tClass.get(i).childNodes[0].nodeValue.length//$tClass.get(i).innerText.length//
							};
						}
						selectionData.push(data);
					}

				}

			}

			return selectionData;

		},


		//获取选中区域文本的起止数据
		"getSelectionDataV2" : function(objSelection){

			var selection = typeof objSelection == "undefined" ? window.getSelection() : objSelection;
			var $tClass = $("." + MarkUtil.markSpanClassName);
			//console.log("初始selection:",selection);

			//默认认为选中的selection都是文本节点，但还需要判断anchorNode和focusNode不为文本节点的情况
			//例如选中了图片链接，或者恰好选中了整个元素节点，当节点不为文本节点时，需要另外记录所选元素节点的tagName和tagIndex
			//其中tagName用于获取tagIndex，并区分其他类型节点；tagIndex用于找到定位此类型的节点位置，tagIndex应当相对固定，不能随DOM结构变化而变。
			//在页面载入数据时，判断数据中endOffset值的合法性，如果为undefined，则表明不能依据此值定为结束节点,应该以tagName和tagIndex来确定结束节点。
			//使用range对象时，也要注意。文本是可以用span标签surround的，但元素节点不可用surround方法，需要另想办法
			//一般，只有起止节点才可能出现非文本节点的情况

			//起止节点不是文本节点，或是文本节点但父级节点不是mark元素（如选中了已高亮文本或者注释按钮文本，默认高亮区域文本是不能被选中的，但也要考虑其他情况），则认为其非法
			//经过测试，目前只发现选中文本时起止节点有两种情况，一种是文本节点，一种是元素节点,默认startNodeIndex和endNodeIndex为0，元素节点为-1，文本节点则为0或正整数值，最大不超过节点的文本长度
			var startMarkNodeIndex = endMarkNodeIndex = 0;

			if( selection.anchorNode.nodeType == 3 && $(selection.anchorNode.parentElement).hasClass(MarkUtil.markSpanClassName) ){
				startMarkNodeIndex = MarkUtil.getElementIndexOfClassName(selection.anchorNode.parentElement,MarkUtil.markSpanClassName);
			}else{
				startMarkNodeIndex = -1;
			}

			if( selection.focusNode.nodeType == 3 && $(selection.focusNode.parentElement).hasClass(MarkUtil.markSpanClassName) ){
				endMarkNodeIndex = MarkUtil.getElementIndexOfClassName(selection.focusNode.parentElement,MarkUtil.markSpanClassName);
			}else{
				endMarkNodeIndex = -1;
			}


			//根据起止节点情况区分，当起始节点为元素节点并且结束节点上文本节点，例如选区从一段文本的开头到此段落的中间，或从一张图片到一段文本的中间
			if(startMarkNodeIndex == -1 && endMarkNodeIndex != -1){

				//anchor节点不是文本节点，需要向前或向后找到最近的mark节点作为anchor节点
				//console.log("起始节点不是文本节点");

				//根据起止节点在DOM中的顺序判断选择的方向，从前向后选和从后向前选，并找到起始节点到结束节点之间距离起始节点最近的一个文本节点，最后重建selection
				//但移动设备上可以对选中的文字既向前选又向后选，尚没有明确这种情况下的anchorNode和focusNode是如何定义的，猜测其一定有anchorNode和focusNode,而不可能两端都是anchorNode或focusNode
				var beginIndex = MarkUtil.getNodeIndexInDOM(selection.anchorNode);
				var stopIndex = MarkUtil.getNodeIndexInDOM(selection.focusNode.parentElement);

				if(stopIndex > beginIndex){
					//从anchorNode往后找,总能找到一个标记节点，且包含了非空文字
					var i = beginIndex + 1;
					while( i <= stopIndex){
						if( $( document.all[i] ).hasClass(MarkUtil.markSpanClassName) && MarkUtil.hasTextNode(document.all[i]) ){
							startMarkNodeIndex = MarkUtil.getElementIndexOfClassName(document.all[i],MarkUtil.markSpanClassName);
							var range = document.createRange();
							range.setStart(document.all[i].childNodes[0],0);//document.all[i]可能包含不止一个文本节点，此处可能会产生错误，留待后面处理
							range.setEnd(selection.focusNode,selection.focusOffset);
							selection.removeAllRanges();
							selection.addRange(range);
							break;
						}
						i++;
					}
				}else{
					//从anchorNode往前找
					var i = beginIndex ;
					while( i >= stopIndex){
						if( $( document.all[i] ).hasClass(MarkUtil.markSpanClassName) && MarkUtil.hasTextNode(document.all[i]) ){
							startMarkNodeIndex = MarkUtil.getElementIndexOfClassName(document.all[i],MarkUtil.markSpanClassName);
							var range = document.createRange();
							range.setStart(selection.focusNode,selection.focusOffset);
							range.setEnd(document.all[i].childNodes[0],document.all[i].childNodes[0].nodeValue.length);
							selection.removeAllRanges();
							selection.addRange(range);
							break;
						}
						i--;
					}
				}

			}

			//起始位置在文字节点中，但结束节点不是文字节点
			if(startMarkNodeIndex != -1 && endMarkNodeIndex == -1){

				//console.log("终止节点不是文本节点");
				//console.log("处理前selection:",selection);
				//注意，此处反转了起止计算节点
				var beginIndex = MarkUtil.getNodeIndexInDOM(selection.focusNode);
				var stopIndex = MarkUtil.getNodeIndexInDOM(selection.anchorNode.parentElement);

				if(stopIndex > beginIndex){
					//从anchorNode往后找
					var i = beginIndex + 1;
					while( i <= stopIndex){
						if( $( document.all[i] ).hasClass(MarkUtil.markSpanClassName) && MarkUtil.hasTextNode(document.all[i]) ){
							endMarkNodeIndex = MarkUtil.getElementIndexOfClassName(document.all[i],MarkUtil.markSpanClassName);
							var range = document.createRange();
							range.setStart(selection.anchorNode,selection.anchorOffset);//document.all[i]可能包含不止一个文本节点，此处可能会产生错误，留待后面处理
							range.setEnd(document.all[i].childNodes[0],0);
							selection.removeAllRanges();
							selection.addRange(range);
							break;
						}
						i++;
					}
				}else{
					//从anchorNode往前找
					var i = beginIndex ;
					while( i >= stopIndex){
						if( $( document.all[i] ).hasClass(MarkUtil.markSpanClassName) && MarkUtil.hasTextNode(document.all[i]) ){
							endMarkNodeIndex = MarkUtil.getElementIndexOfClassName(document.all[i],MarkUtil.markSpanClassName);
							var range = document.createRange();
							range.setStart(selection.anchorNode,selection.anchorOffset);
							range.setEnd(document.all[i].childNodes[0],document.all[i].childNodes[0].nodeValue.length);
							selection.removeAllRanges();
							selection.addRange(range);
							break;
						}
						i--;
					}
				}
				//console.log("处理后selection:",selection);

			}

			//起止位置都不是文字节点
			if(startMarkNodeIndex == -1 && endMarkNodeIndex == -1){
				console.log("起止节点都不是文本节点");
				//注意，此种情况有可能是选中了整个元素节点(例如在ios8中会出现整个节点选中的情况)，暂不处理
				//return false;
				//先判断选择方向，如果反向选，则将起止节点反转，

				var anchorNodeIndex = MarkUtil.getNodeIndexInDOM(selection.anchorNode);
				var focusNodeIndex = MarkUtil.getNodeIndexInDOM(selection.focusNode);
				/*
				//锚节点与焦点节点为同一个节点，例如出现单独一行span标记标签，或单独一个整段,略复杂，稍后开发
				if(anchorNodeIndex == focusNodeIndex){
					var node = selection.anchorNode;
					//只要这个节点中有文字且是标记节点或包含标记节点，则从第一个mark标记开始到最后一个mark标记结束创建selection
					if( ( node.className.match(MarkUtil.markSpanClassName) != null || MarkUtil.hasMarkNode(node) ) && node.innerText != "" ){

						var children = node.childNodes,len = node.children.length;
						for(var i = 0; i < len; i++){
							if(children[i])
						}
					}

				}*/

				//跨节点且锚节点在前
				if(anchorNodeIndex < focusNodeIndex){

					var range = document.createRange();
					var i = anchorNodeIndex;
					while( i <= focusNodeIndex ){
						if( $( document.all[i] ).hasClass(MarkUtil.markSpanClassName) && MarkUtil.hasTextNode(document.all[i]) ){
							startMarkNodeIndex = MarkUtil.getElementIndexOfClassName(document.all[i],MarkUtil.markSpanClassName);
							range.setStart( document.all[i].childNodes[0] , 0 );//document.all[i]可能包含不止一个文本节点，此处可能会产生错误，留待后面处理
							break;
						}
						i++;
					}

					var j = focusNodeIndex;
					while( j >= anchorNodeIndex ){
						if( $( document.all[j] ).hasClass(MarkUtil.markSpanClassName) && MarkUtil.hasTextNode(document.all[j]) ){
							endMarkNodeIndex = MarkUtil.getElementIndexOfClassName(document.all[j],MarkUtil.markSpanClassName);
							range.setEnd( document.all[j] , document.all[j].childNodes[0].nodeValue.length );//document.all[i]可能包含不止一个文本节点，此处可能会产生错误，留待后面处理
							break;
						}
						j--;
					}

					selection.removeAllRanges();
					selection.addRange(range);
				}

				//跨节点且锚节点在后
				if(anchorNodeIndex > focusNodeIndex){
					var range = document.createRange();
					var i = anchorNodeIndex;
					while( i >= focusNodeIndex ){
						if( $( document.all[i] ).hasClass(MarkUtil.markSpanClassName) && MarkUtil.hasTextNode(document.all[i]) ){
							startMarkNodeIndex = MarkUtil.getElementIndexOfClassName(document.all[i],MarkUtil.markSpanClassName);
							range.setEnd( document.all[i].childNodes[0] , document.all[i].childNodes[0].nodeValue.length );
							break;
						}
						i--;
					}

					var j = focusNodeIndex;
					while( j <= anchorNodeIndex ){
						if( $( document.all[j] ).hasClass(MarkUtil.markSpanClassName) && MarkUtil.hasTextNode(document.all[j]) ){
							endMarkNodeIndex = MarkUtil.getElementIndexOfClassName(document.all[j],MarkUtil.markSpanClassName);
							range.setStart( document.all[j] , 0 );
							break;
						}
						j++;
					}

					selection.removeAllRanges();
					selection.addRange(range);
				}
			}


			//开始根据选择方向处理数据
			var selectionData = [];
			var direction = 1;//选取文字方向，1：正向，-1：反向

			//当反向选择时，交换起止节点
			if(startMarkNodeIndex > endMarkNodeIndex){
				direction = -1;
				var t = startMarkNodeIndex;
				startMarkNodeIndex = endMarkNodeIndex;
				endMarkNodeIndex = t;
			}

			//按是否跨节点，分为两种情况
			if(startMarkNodeIndex == endMarkNodeIndex){

				//当不跨节点时，选择文字都位于同一个t标签内时
				data = {
					"tIndex" : startMarkNodeIndex,
					"startOffset" : (selection.anchorOffset < selection.focusOffset) ? selection.anchorOffset : selection.focusOffset ,
					"endOffset" : (selection.anchorOffset < selection.focusOffset) ? selection.focusOffset : selection.anchorOffset
				}
				selectionData.push(data);

			}else{

				//当跨节点时，可能会出现跨2个节点和跨3个节点以上的情况，循环起止节点
				//已知问题：过渡node中不包含任何文本节点时，调用node.childNodes[0]会出错，此情况已在addMarks方法中做了排除
				//当anchorNode或focusNode不是文本节点时，调用nodeValue.length时会出错，例如包含图片的a标签，恰好选到图片下一段文字之前时，focusNode为下一段文字的元素节点

				if(direction == 1){

					for(var i = startMarkNodeIndex ; i <= endMarkNodeIndex; i += 1){

						//如果选中的mark节点中不仅包含纯文本节点，则跳过
						if( $tClass.get(i).childNodes.length > 1 && $tClass.get(i).childNodes[0].nodeType != document.TEXT_NODE ){
							continue;
						}

						if(i == startMarkNodeIndex){ //起始节点

							data = {
								"tIndex" : i,
								"startOffset" : selection.anchorOffset,
								"endOffset" : selection.anchorNode.nodeValue.length//$tClass.get(i).childNodes[0].nodeValue.length//
							};
						}else if(i == endMarkNodeIndex){ //终止节点
							data = {
								"tIndex" : i,
								"startOffset" : 0,
								"endOffset" : selection.focusOffset
							};
						}else{ //其他过渡节点
							data = {
								"tIndex" : i,
								"startOffset" : 0,
								"endOffset" : MarkUtil.hasTextNode(MarkUtil.getMarkNodeByIndex(i)) ? $tClass.get(i).childNodes[0].nodeValue.length : 0//$tClass.get(i).innerText.length//
							};
						}
						selectionData.push(data);
					}

				}else if(direction == -1){

					for(var i = startMarkNodeIndex ; i <= endMarkNodeIndex; i += 1){

						//如果选中的mark节点中不仅包含纯文本节点，则跳过
						if( $tClass.get(i).childNodes.length > 1 && $tClass.get(i).childNodes[0].nodeType != document.TEXT_NODE ){
							continue;
						}

						if(i == startMarkNodeIndex){
							data = {
								"tIndex" : i,
								"startOffset" : selection.focusOffset,
								"endOffset" : $tClass.get(i).childNodes[0].nodeValue.length//selection.focusNode.nodeValue.length //
							};
						}else if(i == endMarkNodeIndex){
							data = {
								"tIndex" : i,
								"startOffset" : 0,
								"endOffset" : selection.anchorOffset
							};
						}else{
							data = {
								"tIndex" : i,
								"startOffset" : 0,
								"endOffset" : MarkUtil.hasTextNode(MarkUtil.getMarkNodeByIndex(i)) ? $tClass.get(i).childNodes[0].nodeValue.length : 0//$tClass.get(i).innerText.length//
							};
						}
						selectionData.push(data);
					}

				}

			}
			return selectionData;


		},

		//格式化overlaydiv中的正文文本
		'formatTextNodes':function(){
			//获取所有的文本节点,遍历后加上t标签
			//此处可以更改为其他节点，防止内容以外的元素被格式化
			var textNodes = MarkUtil.getTextNodes(document.body,true);

			_.each(textNodes,function(ele,idx){

				//2016.8.12
				//排除正文overlaydiv以外的节点,在分享出去的页面上，那些节点可能包含了广告等部分
				if($(ele.parentElement).parents("#overlaydiv").length == 0){
					return false;
				}

				//改进方案：将一个文本节点按标点分割分割为若干个文本节点，并包裹为标记节点
				var text = ele.nodeValue;
				//var regPunc = /，|。|！|；|：|？/g;//原标点减少为3种，从第二版代码起使用
				//var regPunc = /。|！|？/g;//但修改后会影响原有高亮数据，暂时没有好的办法
				//根据数据版本号格式化文本，并确定切分标点
				var regPunc;
				if(MarkUtil.dataFormatVersion == 1){
					regPunc = /，|。|！|；|：|？/g;
				}else if(MarkUtil.dataFormatVersion == 2){
					regPunc = /。|！|？/g;
				}
				var arrNodes = [];
				if(text != null){
					if(text.match(regPunc) != null){
						var html = text.replace(regPunc,'$&</span><span class="'+ MarkUtil.markSpanClassName +'">');
						html = '<span class="'+ MarkUtil.markSpanClassName +'">' + html + '</span>';
						$(ele).replaceWith(html);
					}else{
						$(ele).wrap('<span class="'+ MarkUtil.markSpanClassName +'"></span>');
					}
				}

			});
			

			//对旧版数据做增加两个空白节点处理以兼容新的处理逻辑
			if(MarkUtil.dataFormatVersion == 1 ){
				$('<span class="sqt"> </span><span class="sqt"> </span>').prependTo("#overlaydiv")
			}

			//格式化完成后通知app,仅ios使用
			try{
				formatComplete();
			}catch(ex){
				if(window.console && console.log){
					console.log(ex)
				}
			}
		}
		

	};
	window.MarkUtil = MarkUtil;
})(jQuery);

/**
* 正文工具组件
* ver 1.0
*/
(function($){
	var ArticleUtil = {
	    
		//朗读时高亮文本classname
		"highlightReadClassName" : "mark-read",
		
		
		//清理正文空白节点和空白文本，但仅限于overlaydiv
		"removeBlankNode" : function(){
			//删除空白文本
			var emptyTextNodes = [];
			var container_div = document.getElementById("overlaydiv");
			if(!container_div){
				return false;
			}
			MarkUtil.traverseDOM(container_div,function(obj){
				if(obj != null && obj.nodeType == 3 && (obj.nodeValue.match(/\S/g) == null) ){
					emptyTextNodes.push(obj);
				}
			});
			_.each(emptyTextNodes,function(ele,idx){
				$(ele).remove();
			});

			//删除空白元素节点
			var emptyElementNodes = [];
			var exceptionNode = new RegExp(/IMG|EMBED|INPUT|AREA|LINK|VIDEO|AUDIO|BR/g);
			var content_div = document.getElementById('innerdiv');
			MarkUtil.traverseDOM(content_div,function(obj){
				if( obj.nodeType == 1 && obj.nodeName.match(exceptionNode) == null && ( obj.childNodes.length == 0 || obj.innerHTML.match(/\S/g) == null ) ){
					emptyElementNodes.push(obj);
				}
			});
			_.each(emptyElementNodes,function(ele,idx){
				$(ele).remove();
			});
		},
		
		//获取所有已格式化文本的节点数据
		'getMarkText':function(str_sep){
			var result = [];
			var sep = typeof str_sep == "undefined" ? "," : str_sep;
			$("." + MarkUtil.markSpanClassName).each(function(i,v){
				if(v.innerText.match(/\S/g) != null && v.childElementCount == 0){
					result.push(v.innerText);
				}
			});
			return result.join(sep);
		},
		
		//获取所有已格式化文本的节点数据,，返回数组
		'getMarkArray' : function(){
			var result = [];
			var sep = typeof str_sep == "undefined" ? "," : str_sep;
			$("." + MarkUtil.markSpanClassName).each(function(i,v){
				if(v.innerText.match(/\S/g) != null && v.childElementCount == 0){
					result.push(v.innerText);
				}
			});
			return result;
		},
		//按bodytext获取字符串并且按标点分成数组，标点不保留
		'getMarkArrayV2' : function(){
			var bodyText = document.documentElement.innerText; 
			var iframes = document.documentElement.getElementsByTagName("iframe");
			if (iframes) { 
			    for (var i=0;i<iframes.length;i++) { 
					try{ 
						var iframeDocument = iframes[i].contentDocument; 
						if (iframeDocument) { 
							bodyText += iframes[i].contentDocument.documentElement.innerText; 
						} 
					}catch(e){
						console.log(e);
					} 
				}
			} 
			var text_arr = bodyText.split(/\u3002|\uff01|\uff1f/g);
			return text_arr;
		},
		
		//按bodytext获取字符串并且按标点分成数组，标点保留
		'getMarkArrayV3' : function(){
			var bodyText = document.documentElement.innerText; 
			var iframes = document.documentElement.getElementsByTagName("iframe");
			if (iframes) { 
			    for (var i=0;i<iframes.length;i++) { 
					try{ 
						var iframeDocument = iframes[i].contentDocument; 
						if (iframeDocument) { 
							bodyText += iframes[i].contentDocument.documentElement.innerText; 
						} 
					}catch(e){
						console.log(e);
					} 
				}
			} 
			var text_arr = bodyText
				.replace(/\s/g,'') //替换空白字符
				.replace(/(\u3002)([^\u3002])/g,"$1###$2") //替换边界句号
				.replace(/(\uff01)([^\uff01])/g,"$1###$2") //替换边界问号
				.replace(/(\uff1f)([^\uff1f])/g,"$1###$2") //替换边界叹号
				.split("###");//生成数组
			return text_arr;
		},
		
		//Get the Mark Array ,include the highlighted element 
		'getMarkArray' : function(){
			var result = [];
			var sep = typeof str_sep == "undefined" ? "," : str_sep;
			$("." + MarkUtil.markSpanClassName + ",." + MarkUtil.activeClassName).each(function(i,v){
				if(v.innerText.match(/\S/g) != null && v.childElementCount == 0){
					result.push(v.innerText);
				}
			});
			return result;
		},
		
		//获取除标题外已格式化文本的节点数组，最外层为innerdiv
		'getSentenceArray' : function(){
			var result = [];
			var sep = typeof str_sep == "undefined" ? "," : str_sep;
			var text_div = document.getElementById("innerdiv");
			var text_arr = 
			    text_div.innerText
				    .replace(/\s/g,'') //替换空白字符
			        .replace(/(\u3002)([^\u3002])/g,"$1###$2") //替换边界逗号
					.replace(/(\uff01)([^\uff01])/g,"$1###$2") //替换边界句号
					.replace(/(\uff1f)([^\uff1f])/g,"$1###$2") //替换边界叹号
					.split("###");//生成数组
			result = text_arr;
			
			return result;
		},
		
		//获取除标题外已格式化文本的节点字符串，默认以###分割，最外层为innerdiv
		'getSentenceText' : function(str_sep){
			var result = [];
			var sep = typeof str_sep == "undefined" ? "###" : str_sep;
			var text_div = document.getElementById("innerdiv");
			var text = text_div.innerText.replace(/\s/g,'').replace(/(\u3002)([^\u3002])/g,"$1"+sep+"$2").replace(/(\uff01)([^\uff01])/g,"$1"+sep+"$2").replace(/(\uff1f)([^\uff1f])/g,"$1"+sep+"$2");
			
			return result;
		},
		
		//朗读时高亮指定文本
		'highLightReadText':function(index){
			var $sqt = $("." + MarkUtil.markSpanClassName);
			$sqt.removeClass(ArticleUtil.highlightReadClassName);
			$sqt.eq(index).addClass(ArticleUtil.highlightReadClassName);
		},
		
		//获得选中文字所在分句及以后的分句，如果选中的不是一整句话，则返回其所在的那句话
		'getRemainSentences' : function(str_sep){
			var selection = window.getSelection();
			var sep = typeof str_sep == "undefined" ? "," : str_sep;
			var result = [];
			if(selection.type.toLowerCase() == "range"){
				var parent = selection.anchorNode.nodeType == document.TEXT_NODE ? selection.anchorNode.parentElement : selection.anchorNode;
				
				if(parent.className.match(MarkUtil.markSpanClassName) != null){
					$("." + MarkUtil.markSpanClassName).each(function(i,v){
						var p_index = MarkUtil.getElementIndexOfClassName(parent,MarkUtil.markSpanClassName);
						if( p_index <= i && parent.innerText != "" && parent.childElementCount == 0){
							result.push(v.innerText);
						}
					});
				}
			}
			return result.join(sep);
		},
		
		//获得选中文字所在分句及以后的分句，如果选中的不是一整句话，则返回其所在的那句话
		'getRemainSentences' : function(str_sep){
			var selection = window.getSelection();
			var sep = typeof str_sep == "undefined" ? "," : str_sep;
			var result = [];
			if(selection.type.toLowerCase() == "range"){
				var parent = selection.anchorNode.nodeType == document.TEXT_NODE ? selection.anchorNode.parentElement : selection.anchorNode;
				
				if(parent.className.match(MarkUtil.markSpanClassName) != null || parent.className.match(MarkUtil.activeClassName) != null ){
					$("." + MarkUtil.markSpanClassName + ",." +MarkUtil.activeClassName).each(function(i,v){
						var p_index = MarkUtil.getElementIndexOfClassName(parent,MarkUtil.markSpanClassName);
						if(p_index == -1){
							p_index = MarkUtil.getElementIndexOfClassName(parent,MarkUtil.activeClassName);
						}
						if( p_index <= i && v.innerText.match(/\S/g) != null && v.childElementCount == 0){
							result.push(v.innerText);
						}
					});
				}
			}
			return result.join(sep);
		},
		
		//Get the index of selected sentence in the Mark Array
		'getCurrentSentenceIndex' : function(){
			var arrText = ArticleUtil.getMarkArray();
			var selection = window.getSelection();
			var result = null;
			if(selection.type.toLowerCase() == "range"){
				var parent = selection.anchorNode.nodeType == document.TEXT_NODE ? selection.anchorNode.parentElement : selection.anchorNode;
				for(var i = 0,len = arrText.length;i < len; i+=1 ){
					//only the markSpanClassName element can be selected
					if(arrText[i].indexOf(parent.innerText) != -1 && parent.className.match(MarkUtil.markSpanClassName) != null){
						result = i;
					}
				}
			}
			return result;
		},
		
		//返回选中文字所在分句的索引值，基于getMartText数组
		'getCurrentSentenceIndexV2' : function(){
			var arrText = ArticleUtil.getMarkArrayV2();
			var selection = window.getSelection();
			var result = null;
			if(selection.type.toLowerCase() == "range"){
				var parent = selection.anchorNode.nodeType == document.TEXT_NODE ? selection.anchorNode.parentElement : selection.anchorNode;
				var selection_arr = selection.toString().split(/\u3002|\uff01|\uff1f/g);
				var index = 0;
				// if(selection_arr.length > 1){
					// index = selection_arr.length - 1;
				// }
				if(selection_arr[index].match(/\S/g) == null){
					index += 1;
				}
				//简单实现就是直接找，复杂实现需要考虑前后字符，但过于复杂，可能卡死
				for(var i = 0,len = arrText.length;i < len; i+=1 ){
					if(arrText[i].indexOf(selection_arr[index]) != -1){
						result = i;
						break;
					}
				}
			}
			return result;
		}
		
	};
	window.ArticleUtil = ArticleUtil;
})(jQuery);


